//========================================================================================
//
//	File:				BmpFacet.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef BMPFACET_H
#define BMPFACET_H

// ----- Framework Includes -----

#ifndef FWFACET_H
#include "FWFacet.h"
#endif

//========================================================================================
//	 Forward Declarations
//========================================================================================

class XMPFacet;
class XMPShape;
class CBitmapPart;
class FW_CGraphicContext;

//========================================================================================
//	 CBitmapFacet
//========================================================================================

class CBitmapFacet : public FW_CFacet
{
//----------------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
	CBitmapFacet();
	virtual ~CBitmapFacet();
	void InitBitmapFacet(XMPFacet* xmpFacet, CBitmapPart *bitmapPart);
			
//----------------------------------------------------------------------------------------
//	 Inherited API
//
public:
	virtual void 			Draw(FW_CGraphicContext *gc);
	virtual FW_Boolean 	DoMouseDown(const FW_CPoint& where,
										XMPEventData event);

//----------------------------------------------------------------------------------------
//	 New API
//
public:
	FW_CPoint				GetZoomRatio() const;
	
//----------------------------------------------------------------------------------------
//	 Data Members
//
private:
	CBitmapPart		*fBitmapPart;
};

#endif
