//========================================================================================
//
//	File:				BmpFrame.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef BMPFRAME_H
#define BMPFRAME_H

// ----- Framework Includes -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

//========================================================================================
//	 Forward Declarations
//========================================================================================

class CBitmapPart;
class FW_CFacet;
class XMPFrame;

//========================================================================================
//	 class CBitmapFrame
//========================================================================================

class CBitmapFrame : public FW_CFrame
{
//----------------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
	CBitmapFrame();
	void InitBitmapFrame(XMPFrame* xmpFrame, CBitmapPart* bitmapPart);
	virtual ~ CDECL CBitmapFrame();
	
//----------------------------------------------------------------------------------------
//	 Inherited API
//
public:
	FW_CFacet* 			NewFacet(XMPFacet* xmpFacet);
	virtual FW_Boolean	DoMenuEvent(XMPMenuBar *menuBar, XMPCommandID commandID);
	virtual void		DoAdjustMenus(XMPMenuBar* menuBar);

	virtual void		FocusStateChanged(XMPTypeToken focus, FW_Boolean newState);

//----------------------------------------------------------------------------------------
//	 New API
//
public:
	FW_CPoint			GetZoomRatio() const;
	void				AdjustBitmapSize(XMPCommandID commandID);
	
//----------------------------------------------------------------------------------------
//	 Data Members
//
private:
	CBitmapPart* 		fBitmapPart;
};

#endif
