//========================================================================================
//
//	File:				ButtonPart.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef _BUTTONPART_
#define _BUTTONPART_

#ifndef _BUTTONDEF_
#include "ButtonDef.h"
#endif

// ----- Framework Includes -----

#ifndef FWCTLMGR_H
#include <FWCtlMgr.h>
#endif

//==============================================================================
//	 class CButtonPart
//==============================================================================

struct FW_CPoint;
struct FW_CRect;

//==============================================================================
//	 class CButtonPart
//==============================================================================

#define kCButtonPartID "appl:cbuttonpart$class,1.0.0"

class CButtonPart : public FW_CCtlMgrPart
{
//------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
	CButtonPart();
	virtual ~ CDECL CButtonPart();
	
//------------------------------------------------------------------------------
//	 Inherited API
//
public:
	virtual FW_CFrame*			NewFrame(XMPFrame* xmpFrame, XMPTypeToken presentation);
	
protected:
	virtual ControlHandle		CreateControlHandle(XMPPlatformWindow window, 
													const FW_CRect& controlRect);
	virtual XMPValueType		GetContentPropertyValueType() const;
									
};

//==============================================================================
//	 class CButtonFrame
//==============================================================================

#define kCButtonFrameID "appl:cbuttonframe$class,1.0.0"

class CButtonFrame : public FW_CCtlMgrFrame
{
//------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
	CButtonFrame();
	virtual void InitButtonFrame(XMPFrame* frame, FW_CPart* part);	
	virtual ~ CDECL CButtonFrame();

//------------------------------------------------------------------------------
//	 Inherited API
//
public:
	virtual void			UpdateUsedShape();

};

#endif
