//========================================================================================
//
//	File:				ClockFra.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Lonnie Millett
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef CLOCKFRA_H
#define CLOCKFRA_H

// ----- Framework Includes -----

#ifndef FWFRAME_H
#include <FWFrame.h>
#endif

// ----- Graphic Includes -----

#ifndef FWRECT_H
#include <FWRect.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class CClockFrame;

//==============================================================================
// Classes used by this interface
//==============================================================================

class CClockPart;
class FW_CFacet;
class XMPFrame;
class XMPShape;
class XMPMacMenuBar;

//==============================================================================
// CClockFrame
//==============================================================================

class CClockFrame : public FW_CFrame
{
public:
	CClockFrame();
	void InitClockFrame(XMPFrame* xmpFrame, CClockPart* clockPart);
	virtual ~ CDECL CClockFrame();
	
	CClockPart* 		GetClockPart();
	
	FW_CFacet* 			NewFacet(XMPFacet* xmpFacet);
	virtual void 		FacetAdded(FW_CFacet* facet);
	virtual void 		FacetRemoved(FW_CFacet* facet);
	
	virtual void 		FrameShapeChanged();
	
	virtual void 		UpdateClock(unsigned long tickCount);
	virtual XMPShape* 	GetNewFrameShape(FW_CFacet* facet);
	
private:
	CClockPart* 		fClockPart;
	FW_CRect 			fDigitalClockRect;
};

//----------------------------------------------------------------------------------------
// CClockFrame::GetClockPart
//----------------------------------------------------------------------------------------
inline CClockPart* CClockFrame::GetClockPart()
{
	return fClockPart;
}

#endif
