//========================================================================================
//
//	File:				ClockSel.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Lonnie Millett
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef CLOCKSEL_H
#define CLOCKSEL_H

// ----- FrameWork Includes -----

#ifndef FWSELECT_H
#include <FWSelect.h>
#endif

//==============================================================================
//	 Forward Declarations
//==============================================================================

class CClockPart;
class FW_CFacet;

//==============================================================================
//	 class CClockSelection
//==============================================================================

class CClockSelection : public FW_CSelection
{
	
//------------------------------------------------------------------------------
//	 Initialization/Destruction
//------------------------------------------------------------------------------
public:
				CClockSelection();
	void		InitClockSelection(CClockPart* clockPart);
	virtual 	~CClockSelection();
	
//------------------------------------------------------------------------------
//	 Inherited API
//------------------------------------------------------------------------------
public:
	virtual void		CloseSelection();
	virtual void		SelectAll();
	virtual FW_Boolean	IsEmpty() const;
	virtual FW_Boolean	DoClear();
	
	virtual void		ExternalizeSelection(XMPStorageUnit* storageUnit, FW_CFrame* commandFrame, XMPCloneKind cloneKind);
	virtual FW_Boolean	InternalizeSelection(XMPStorageUnit* storageUnit, XMPCloneKind cloneKind);

//------------------------------------------------------------------------------
//	 Data Members
//------------------------------------------------------------------------------
private:
	CClockPart*			fClockPart;
};

#endif