//	File:		ClockPart.r
//
//	Contains:	Resources for ClockPart
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.


// ClockPar.r
// Copyright 1984-1993 Apple Computer, Inc. All rights reserved.

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "StdTypes.r"
#include "StdDefs.h"
#include "CClockDef.h"

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (FW_kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleClockKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kXMPCategoryTime
			}
		}
	}
};

resource kNameMappings (FW_kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kCClockPartID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kSampleClockKind
			}
		}
	}
};

resource kNameMappings (FW_kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kCClockPartID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleClockEditorUserString
		}
	}
};

resource kNameMappings (FW_kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleClockKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleClockKindUserString
		}
	}
};

resource kNameMappings (FW_kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kXMPCategoryTime,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleClockCategoryUserString
		}
	}
};

resource kNameMappings (FW_kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kSampleClockKind,
		kXMPIsMacOSType {
			kSampleClockOSType
		}
	}
};

resource 'MENU' (kClockTypeMenu, preload) {
	kClockTypeMenu, textMenuProc,
	0b1111111111111111111111111111111,
	enabled, "Clock",
	{
		"Display as Digital",
			noicon, nokey, nomark, plain;
	}
};

resource 'MENU' (kClockSoundsMenu, preload) {
	kClockSoundsMenu, textMenuProc,
	0b1111111111111111111111111111111,	/* disable dashed line */
	enabled, "Sounds",
	{
		"None",
			noicon, nokey, nomark, plain;
		"Tick",
			noicon, nokey, nomark, plain;
		"Chime",
			noicon, nokey, nomark, plain;
		"Both",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Play Chime Sound",
			noicon, nokey, nomark, plain;
	}
};

resource 'STR#' (kClockPartStrings, preload) {
	{
	"Display as Analog";
	"Display as Digital";
	"12:59:59 MM";
	"OpenDoc"
	}
};

resource 'snd ' (kClockChime, "chime", preload) {
	FormatOne {
		{	/* array Synthesizers: 1 elements */
			/* [1] */
			sampledSynth, 160
		}
	},
	{	/* array SoundCmnds: 1 elements */
		/* [1] */
		hasData,
		bufferCmd {
			20
		}
	},
	{	/* array DataTables: 1 elements */
		/* [1] */
		3978,
		0x1CFA2E8B,
		3976,
		3977,
		0x0,
		0x3C,
		$"478C 6ACB B768 7147 9CA8 596E 3B86 BC5B"
		$"653D 74C5 878F 464D BC93 9556 1DAD A4A2"
		$"6D26 908A 8D80 1771 8393 A72F 6779 7CC2"
		$"4D59 7779 CE70 5876 67CF 9562 764C B6AD"
		$"7381 3EA4 B670 8129 65AA 7CA2 4958 AB86"
		$"AD56 378F 7CB9 9044 8D71 B6A7 4379 619C"
		$"BC56 775C 81C6 6874 5964 BD76 8164 4FB7"
		$"958F 7A37 9C8A 898C 3281 9090 A841 6783"
		$"87BD 5961 7D74 C377 5B77 62C0 9562 764A"
		$"A4A5 7380 4692 B37F 8A3B 65AB 819C 4D50"
		$"A287 A865 3E92 87B6 8F43 7F79 ABA1 466E"
		$"679C B758 675E 81C6 7970 5E68 C087 775F"
		$"4DB1 9E8C 713A 939C 908A 387C 9E98 A444"
		$"5C8A 8FB4 6153 7F81 BA79 526E 6EBA 9859"
		$"6B58 A5A8 686E 4F8D B67D 7947 6DB1 9090"
		$"5859 A592 9C65 438C 90A7 8644 7684 A29B"
		$"4D6A 799E B15F 5C64 84BA 7965 5F70 B790"
		$"6E62 59AA A484 6D4A 8CA2 8F7F 4976 9E99"
		$"934C 5B8D 93A2 644F 7C8C AB7D 506D 7FB0"
		$"985E 6468 A1A7 6E65 5C8D B383 6D52 70AA"
		$"967F 5B5E 9C9E 9067 5087 9C9C 7C4A 6E90"
		$"A192 565E 819C A56B 566D 8DAD 845F 627A"
		$"AA96 6B5F 6A9F A77F 6559 84A7 8D6E 536E"
		$"9E9C 8058 5B8D 9F95 6A53 7A99 9F7F 5568"
		$"8AA1 9362 597A 99A2 7759 688C A78A 615E"
		$"76A1 9C70 5C65 90A7 8365 597A A595 7459"
		$"6799 9F87 6459 87A1 9876 5374 969E 8A56"
		$"6187 9B9B 6858 7790 A77C 5968 81A7 9264"
		$"626B 9EA4 7465 5E8A AB86 7159 74A7 9580"
		$"5E5F 9698 8F67 4F83 9398 7D4C 718A 9C95"
		$"5865 8096 A567 5B6D 84AD 7C62 6774 AE92"
		$"6D68 61A2 A17A 7052 87A2 847C 5073 9F8D"
		$"8C55 5B92 8F9F 6852 8687 A57F 4D76 7CA4"
		$"9858 6B6B 96A8 6A6E 6486 B379 735E 6AAE"
		$"897C 6455 9F90 8471 498F 9892 8646 768D"
		$"909B 5268 878C AD62 5C7C 7FB4 7F5F 766D"
		$"AD8D 6171 5BA2 A26E 764D 84A7 7983 5271"
		$"AA83 8F59 569E 879F 714F 9083 A184 4981"
		$"7C9F 9E4F 716D 8CAB 5E70 6A7F B770 6E64"
		$"65B6 8479 6E52 A58F 7D7A 4693 9989 8F46"
		$"7A93 879F 526A 8F80 AB5F 5884 77B3 7D58"
		$"7F68 AB90 597A 5EA1 A868 7D52 83AD 7187"
		$"5970 B17D 8F61 55A7 869B 794C 9680 9887"
		$"4384 7D96 9F4A 7674 87B3 5E74 747A BA6E"
		$"6B6D 62B7 8776 7752 A792 7781 4995 9E80"
		$"9046 7799 7F9F 5567 967C A864 558C 76B1"
		$"8055 8468 A592 5580 629B AB62 7F59 80B0"
		$"7086 616D B179 8965 52A5 8190 7947 9581"
		$"8F8A 4484 838F 9F4A 7379 81AE 5E70 7C77"
		$"B771 6B79 64B4 8770 7D55 A190 7080 4D90"
		$"9C77 8D4A 749C 7C9C 5C67 9B7D A268 538D"
		$"77A8 8355 866D 9E95 5681 6A95 AA61 7C61"
		$"7CAD 6D7D 6568 AA77 806A 55A4 868C 7C4D"
		$"9386 8A8C 4A84 898A 9E52 7380 80AA 656D"
		$"8077 AE74 6779 67AD 896A 7A59 9992 6D7F"
		$"558C 9F77 8955 749E 7D96 6468 9B7F 9B6D"
		$"568D 7CA1 8758 8676 9995 5B7D 708F A262"
		$"7667 79A8 717C 6D6B A77D 7C6E 5B9F 8A86"
		$"7F55 8F8C 8789 5381 8D89 995B 7084 81A2"
		$"6B6A 8179 A176 6177 6DA1 8A6A 7A64 9595"
		$"707F 5F86 9F7A 845F 739B 818D 6B6A 9686"
		$"9574 5E8C 8196 8459 7D7C 8F90 5F76 7689"
		$"9C6A 706E 7DA2 7C79 7171 A186 7973 6498"
		$"9081 7D5F 8992 8686 617C 8F87 8D62 6B83"
		$"8396 7067 7F7F 997F 6577 7798 8F6D 7770"
		$"8D96 7779 6B84 9B7F 7C68 7396 8683 6E68"
		$"8C89 8774 6180 868C 8061 7681 8C8D 6A71"
		$"7D87 9674 6B74 7F98 8371 7377 958C 7773"
		$"6E8D 9380 7767 7D90 847D 6873 8C8A 866E"
		$"6A83 898D 7968 7C86 9084 6B76 808F 8F73"
		$"7179 8693 7D71 7480 9687 7670 748D 8D7A"
		$"706B 838F 8177 6879 8D86 7F6B 6E87 8A87"
		$"746A 8089 8D7F 6A77 838F 8A6E 737D 8992"
		$"7670 7781 9580 7170 7490 8977 736E 898C"
		$"7D79 6A80 9083 7F6A 748C 8687 716E 8787"
		$"8F79 6A80 8490 8468 777C 8A8A 6D74 7684"
		$"9377 7371 7A95 7F77 7370 9086 7C76 688D"
		$"8D84 8067 818C 8489 6A79 8A86 906E 6E81"
		$"7F93 776A 7A76 9080 6879 708F 8D71 7A6B"
		$"8390 767C 6B7C 967F 836E 7093 8187 7665"
		$"8A80 877F 6283 8189 8964 7979 808F 6774"
		$"777C 9671 7479 749B 7F76 7A6A 9286 797F"
		$"678C 8F7F 8762 7D8C 7C8D 6874 8C7A 906D"
		$"6886 7793 7C65 8071 8F86 6781 718D 936D"
		$"806D 7F98 7181 7076 9B79 8473 6896 8087"
		$"7D62 8D7F 8686 5F86 8083 8F61 797A 7C98"
		$"6B77 7D76 9B73 717C 6D9B 8174 8064 9086"
		$"7181 6189 9079 8A64 7A8F 7790 6A6E 8D74"
		$"9271 6489 7393 8164 8670 8C8A 6483 7087"
		$"966A 816D 7A9B 7384 7470 9C79 8377 6496"
		$"7D84 815E 8A7D 7F89 5C81 807F 9561 777D"
		$"7799 6B73 7F70 9B76 7181 6B9C 8774 8464"
		$"8F8A 7389 6484 9276 8A62 738F 7390 6E6D"
		$"9277 9379 648A 7492 8664 8671 8A92 6886"
		$"7486 9C6D 8170 749B 7381 746A 9977 7F79"
		$"5F92 7F83 865E 8780 7D8C 5E80 847D 9865"
		$"7781 769C 7373 8370 9B7C 6E81 6A98 8A71"
		$"8361 868A 7084 6280 9377 8D6A 7192 778F"
		$"736A 8F77 8F7C 6289 7790 8A64 8171 8690"
		$"677F 717F 996D 7C71 7199 767D 7768 957D"
		$"807F 6592 8683 8761 8381 7C8C 627C 8680"
		$"986B 7381 7798 766E 7F70 9580 6E80 6D93"
		$"8C73 8167 8490 7684 687D 957C 896A 6D8D"
		$"7A8A 7467 897C 8F81 6586 7C8C 8A65 7D74"
		$"8392 6D7C 777F 9973 7A74 7398 7D7A 766A"
		$"9283 7C7C 6489 8780 8362 7D86 808C 6877"
		$"847F 926E 6E80 7A95 7C70 8077 9384 6E7A"
		$"6E8C 8D73 7C6A 8190 7980 6D79 927F 846E"
		$"6D8C 8189 7768 8480 897D 647D 7D89 896A"
		$"797C 8793 7477 797F 957A 7371 7392 837A"
		$"776E 8D87 7A77 6581 8980 7F67 798A 8487"
		$"6D71 8483 8C74 6D7F 8192 816E 7A7A 8F89"
		$"7076 7489 8F77 766E 7F8F 7D79 6E76 8D83"
		$"7F70 6D89 8987 7A6B 8189 8980 6B79 848A"
		$"8970 717F 868F 776E 7780 8F7F 6E71 798F"
		$"8976 7171 868A 7C73 6D7F 8F84 7C6D 768C"
		$"8A84 7370 848A 8977 6A7A 868A 806B 7380"
		$"8A87 736E 7784 8C79 6B70 7D8F 8474 7179"
		$"8C8C 7C73 7184 8F83 776D 7A8F 897D 6E71"
		$"868A 8371 6A7D 8789 7A6A 7483 8983 6D70"
		$"7D89 8D76 7079 8692 8170 717A 8D86 736E"
		$"7189 8D7D 746D 818F 8379 6A74 8A84 7F6B"
		$"6A84 8989 776A 7F89 8F83 6B77 818F 8C6E"
		$"7179 8790 7771 7480 9580 7370 7692 897A"
		$"736B 878A 7F76 6780 8D86 8068 768A 898A"
		$"6E70 8487 8F76 6A7C 8092 836B 777A 908C"
		$"7073 7087 9074 736B 7C93 807A 6D73 9387"
		$"8371 6A8C 8987 7964 7F86 8983 6577 848C"
		$"906D 717D 8495 746D 7479 957C 6D71 7192"
		$"8A76 766B 8C92 7D7C 6881 9281 8165 738D"
		$"868A 6E6D 8986 9079 6580 8092 8365 7777"
		$"8D8D 6B76 7487 9976 7770 7D9B 817C 7073"
		$"9886 7F73 678D 8C86 7D62 838C 8986 6277"
		$"8687 8F67 6D7F 8195 746B 7A7C 9B80 6D77"
		$"7196 8C73 776A 8A92 777C 6580 9680 8065"
		$"7090 8187 6B65 8981 8C76 5F80 8192 8764"
		$"7A7C 8D90 6874 7687 9B71 7370 7A9C 7F79"
		$"7170 9886 7A73 648D 8C81 7C5E 808A 8486"
		$"6279 8C89 936A 6D83 8398 766A 7D7C 9980"
		$"6A79 7496 9070 776A 8995 767A 657D 967C"
		$"7D64 6D92 8387 6E65 8D86 8D79 5F84 8490"
		$"875F 767C 8A90 6773 7986 9B71 7071 799B"
		$"7D73 706D 9586 7671 648D 8F7F 7C5F 808F"
		$"8383 6276 8C86 8F67 6A84 8396 7665 7D7C"
		$"9580 6576 7493 8F6D 746B 8795 7376 677C"
		$"987D 7A68 7096 8786 7168 8D89 8A79 5F83"
		$"878F 8661 7781 8C92 6871 7C86 9973 6D74"
		$"7A9C 8171 7371 9689 7673 678D 907D 7962"
		$"8092 8481 6474 8F87 8C6B 6A87 8693 7767"
		$"7F80 9380 6474 778F 8D6B 7370 8996 7674"
		$"6D7F 987F 7768 7095 8780 7068 8D8C 8979"
		$"6483 8C8D 8464 7686 8C8D 6A6E 7F87 9574"
		$"6A74 7F98 806D 7176 958C 7470 6B8C 927C"
		$"7665 7F93 847F 6876 908A 876B 6A86 898F"
		$"7665 7D84 9081 6574 7D90 8D6D 6E74 8795"
		$"7970 7080 9883 766D 7493 8A7D 6E6A 8A8F"
		$"8476 6580 8F8C 8167 7689 8D8A 6D6D 7D89"
		$"9073 6774 8193 816B 7079 928C 7470 718C"
		$"957D 716A 7D92 8477 6773 8D8C 836D 6B87"
		$"8F8C 7667 7A89 8D7F 6570 808D 8A6D 6B79"
		$"8A92 796B 7181 9383 706B 7690 8D79 6E6E"
		$"8992 8374 6A7F 908A 7A67 7187 8D84 6D6B"
		$"808D 8D77 6876 8790 836B 6D7F 8F8A 736A"
		$"7489 927F 7070 8093 8976 6B74 8C8F 7D6D"
		$"6D84 9286 7468 798D 8D7D 686E 838D 8470"
		$"687C 8D8F 7C6A 7386 9286 706D 7D8F 9077"
		$"6B73 8693 8371 6E7D 928A 776B 7189 8F80"
		$"6E6A 7F90 8979 6876 8A8D 836D 6E84 8F8C"
		$"7668 7989 8F7F 6A71 8190 8A70 6D79 8C90"
		$"7A6E 7081 9383 736B 7792 8D7C 6E70 8990"
		$"8473 6880 8F8A 7C67 7489 8C87 6D6D 808C"
		$"9077 6A77 8493 816B 717C 908C 716D 718A"
		$"927C 716B 8093 8677 6874 8F8A 806D 6A87"
		$"8C89 7667 7D8A 8D80 6874 838F 8A6D 6D7A"
		$"8993 776E 7481 9681 716E 7692 8C79 716E"
		$"8A90 8176 6780 9289 7F68 748C 8A87 6D6D"
		$"8489 8D76 677A 8492 816A 747C 908C 6E70"
		$"7389 9377 706D 7F96 8377 6D76 9389 7F6E"
		$"6A89 8C86 7764 7F8A 8A80 6576 848C 8C6B"
		$"6E7D 8692 746B 7680 9580 6E71 7793 8A76"
		$"716D 8A90 7C76 6880 9283 7D67 738D 8784"
		$"6D6B 8687 8C76 677D 8490 8368 767D 8F8C"
		$"6D71 7687 9276 7170 7F95 8076 7076 9589"
		$"7C71 6B8C 8D83 7764 808A 877F 6577 878A"
		$"8A6B 6E80 8692 766D 7A80 937F 6B74 7793"
		$"8C73 736E 8A92 7974 6A80 9583 7C68 738F"
		$"8683 6E6D 8987 8976 657F 868D 8167 767F"
		$"8C8A 6B73 7A89 9374 7173 7F95 7F74 7074"
		$"9286 7971 6B8C 8D81 7767 818C 847F 6777"
		$"8989 896A 6E83 8792 776D 7D83 9380 6D77"
		$"7A92 8A71 7371 8990 7976 6D81 9581 7C6D"
		$"7690 8680 6E6B 8786 8674 657F 868A 8067"
		$"7781 8A89 6D71 7C87 9074 7076 7F93 8074"
		$"7479 9084 7671 6D89 8A7D 7768 808C 837D"
		$"6A77 8986 846D 6E81 848C 746B 7C83 8F80"
		$"6D79 7D8F 8A70 7374 868C 7673 6E7F 907F"
		$"766D 748D 847D 7170 8787 8477 6B81 898A"
		$"806B 7983 8987 7073 7F87 8F76 7077 7F8D"
		$"7D70 7177 8C84 7473 7189 8C7F 776E 808C"
		$"817C 6D79 8A87 8370 7083 8689 776E 7D83"
		$"8A7D 6D76 7D89 8470 7176 8489 7671 7380"
		$"8D7F 7671 7A8D 867C 7371 8687 8076 6E80"
		$"8784 7C6B 7681 8683 7173 7F86 8977 7079"
		$"818C 7F71 747A 8A86 7674 7686 8A7D 7673"
		$"818C 837C 7079 8986 7F71 7381 8784 766E"
		$"7C84 877D 7179 818A 8674 737C 8689 7973"
		$"7681 8C80 7776 7C8A 867A 7374 8387 7F74"
		$"717D 8683 7A70 7784 8781 7474 8086 8679"
		$"7179 8387 7F71 767F 8986 7974 7984 877C"
		$"7374 7F87 8177 737A 8686 7D74 7481 8781"
		$"7771 7C86 867C 7177 8186 8176 737D 8686"
		$"7C73 7981 8780 7474 7C84 8479 7477 8387"
		$"7F76 747D 8783 7A74 7984 877F 7674 8087"
		$"8379 737A 8486 7F74 7680 8683 7773 7C83"
		$"867D 7479 8086 8176 747A 8486 7C77 7781"
		$"8780 7774 7C86 837C 7476 8386 8077 737F"
		$"8483 7C73 7981 8480 7476 7F83 8379 747A"
		$"8187 7F76 797D 8683 7977 7984 867D 7774"
		$"7F86 807A 747A 8483 7F76 7681 8483 7A74"
		$"7D81 837D 737A 8186 8377 777D 8386 7A76"
		$"7980 877F 7776 7A84 817C 7777 8384 7F7A"
		$"747F 8681 7D74 7A84 8481 7777 8083 8379"
		$"747D 8084 7F74 797D 8483 7777 7983 867C"
		$"7977 7F86 7F7A 767A 8481 7F77 7681 8381"
		$"7C74 7D81 817D 747A 8081 8076 797D 8083"
		$"7977 7A7D 847D 7779 7C84 817A 7A77 8183"
		$"7D7C 767F 8480 7D74 7A81 8080 7777 8080"
		$"817A 767D 8083 7D76 7C7D 8381 777A 7A81"
		$"837A 7A79 7D84 7D7C 797A 8480 7D79 7781"
		$"8180 7A76 7D80 807D 767C 8080 8077 797D"
		$"7F83 7A77 7C7D 837D 797A 7A83 807A 7A79"
		$"8081 7D7C 797D 817D 7D77 7A81 7F7F 7979"
		$"8080 807C 777D 7F81 7F77 7C7D 8080 797C"
		$"7D80 817C 7C7A 7D81 7D7C 7A7C 817F 7C7A"
		$"7980 807F 7D77 7F80 807D 777C 8080 8079"
		$"7A7F 7F81 7A7A 7D7F 817D 7A7C 7C81 807A"
		$"7A7A 8080 7D7D 7A7F 817F 7D7A 7A80 7F7F"
		$"7A7A 8080 807C 7A7F 8080 7F7A 7D7F 8080"
		$"7A7C 7D80 807C 7C7C 7D81 7D7C 7C7C 8180"
		$"7D7C 7A7F 7F7D 7D7A 7F80 807F 7A7D 8080"
		$"7F7A 7C7F 8080 7C7A 7D7D 807D 7A7C 7D81"
		$"807D 7D7D 8080 7D7D 7C7D 807D 7D7A 7D80"
		$"807F 7C7C 7F80 7F7D 7A7F 8080 7F7A 7D7F"
		$"7F7F 7C7D 7F7F 807D 7D7D 7D80 7F7D 7C7C"
		$"807F 7D7C 7C7F 807F 7F7C 7F80 807F 7C7D"
		$"7F7F 7F7C 7C7F 8080 7D7C 7F7F 807F 7C7C"
		$"7D80 7F7C 7C7D 7F80 7D7D 7C7D 7F7D 7D7C"
		$"7C7F 7F7F 7C7C 7F80 7F7D 7C7F 8080 7F7D"
		$"7D7F 807F 7D7D 7F7F 7F79"
	}
};

resource 'snd ' (kClockTick, "tick") {
	FormatOne {
		{	/* array Synthesizers: 1 elements */
			/* [1] */
			sampledSynth, 160
		}
	},
	{	/* array SoundCmnds: 1 elements */
		/* [1] */
		hasData,
		bufferCmd {
			20
		}
	},
	{	/* array DataTables: 1 elements */
		/* [1] */
		355,
		0x2B7745D1,
		353,
		354,
		0x0,
		0x3C,
		$"807F 7A79 7683 8172 7A6A 9754 9D57 839C"
		$"8B6C 73AD 63B9 9AB2 97B5 85BD 97C2 73C5"
		$"55CE 60B4 2778 517C 7DA7 80AB 9789 AA98"
		$"78A4 98D9 53CF 5BC0 4B9E 43D6 46BA 53A7"
		$"A26E C28E A883 9FBE 70C4 4DA7 6FA9 6B9F"
		$"7D8E A362 D050 D137 CB46 BB68 95A6 8E78"
		$"A87F 8990 BC4C B068 A75B C63E C946 C550"
		$"A1A3 678F 965C D036 CE45 B974 74A7 59C6"
		$"7889 A276 9387 9967 AD6F 8D95 67A5 53C6"
		$"4DB8 46B8 4AA3 7274 B535 C645 9495 5BBC"
		$"33CD 4898 6693 659F 4FB3 3CA4 7665 A656"
		$"A76B 908D 45D3 7484 7382 998A 7293 60A1"
		$"7D75 7A79 AD3B AC66 907B 8676 7490 7C73"
		$"7B92 6F7D 6F90 689D 746C 8F75 9277 69AE"
		$"628B 9264 B479 8F8C 72C1 607E 7C7D 9D74"
		$"8376 8D9B 7C85 787A 4A4E 5A79 8B71 7F96"
		$"A67D 424F 7392 7B59 6E7C 8F87 657D 9895"
		$"7D58 5479 807D 7875 9180 7474 777F 7576"
		$"6357 7972 7975 797E 7876 6D78 817C 7975"
		$"7D80 8081 7B7B 7B7B 7776 7B7C 7875 7A7D"
		$"7E7C 7A7B 7C7E 7C7A 7678 7D7D 7D79 7A7B"
		$"7C7E 7C7C 7C7D 7E7D 7D7D 7E7F 7E7E 7E7F"
		$"7F7F 81"
	}
};

