//========================================================================================
//
//	File:				DrawFacet.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWFACET_H
#define DRAWFACET_H

// ----- Framework Includes -----
#ifndef FWFACET_H
#include "FWFacet.h"
#endif

//==============================================================================
// Forward Declaration
//==============================================================================

class CDrawPart;
class CBaseShape;
class FW_CGraphicContext;

//==============================================================================
//	 class CDrawFacet
//==============================================================================

class CDrawFacet : public FW_CFacet
{
//------------------------------------------------------------------------------
//	 Initialization/destruction
//------------------------------------------------------------------------------
public:
	CDrawFacet();
	void IDrawFacet(XMPFacet* facet, CDrawPart* drawPart);
	virtual ~CDrawFacet();

//------------------------------------------------------------------------------
//	 Inherited API
//------------------------------------------------------------------------------
public:	
	virtual void 			Draw(FW_CGraphicContext *gc);

	virtual void			MouseEnter(const FW_CPoint& where);	
	virtual FW_Boolean		DoMouseDown(const FW_CPoint& where,
							 			XMPEventData event);
	virtual FW_Boolean		DoMouseDownInEmbeddedFrame(XMPFacet* embeddedXMPFacet, 
														const FW_CPoint& where, 
														XMPEventData event);
	virtual FW_Boolean		DoMouseDownInEmbeddedFrameBorder(XMPFacet* embeddedXMPFacet, 
															const FW_CPoint& where, 
															XMPEventData event);
	virtual void			ClipEmbeddedFacets();
	
	virtual XMPFacet*		CreateEmbeddedFacet(FW_CProxyFrame *itsFrame, 
												XMPShape* clipShape, 
												XMPTransform* externalTransform, 
						   		 				XMPFacet* siblingFacet, 
												XMPFramePosition position);
//------------------------------------------------------------------------------
//	 New API
//------------------------------------------------------------------------------
public:
	void					DrawGrid(FW_CGraphicContext* gc);
		
protected:
	CBaseShape* 			WhichShape(FW_CGraphicContext* gc, FW_SPlatformPoint mouse, XMPEventData event);

//------------------------------------------------------------------------------
//	 Data Members
//------------------------------------------------------------------------------
private:
	CDrawPart*				fDrawPart;
	EventRecord				fLastDownInEmbeddedFrame;
};
#endif