//========================================================================================
//
//	File:				DrawFrame.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWFRAME_H
#define DRAWFRAME_H

// ----- Framework Includes -----
#ifndef FWFRMING_H
#include "FWFrming.h"
#endif

#ifndef FWPROXY_H
#include "FWProxy.h"
#endif

// ----- OpenDoc Includes -----
#ifndef _SHAPE_
#include <Shape.h>
#endif

//========================================================================================
// Forward Declaration
//========================================================================================

class CDrawPart;
class XMPFrame;
class CProxyShape;
class CBaseShape;
class XMPWindow;

//========================================================================================
// CDrawFrame
//========================================================================================

class CDrawFrame : public FW_CEmbeddingFrame
{
//----------------------------------------------------------------------------------------
// Initialization/destruction
//
public:		
	CDrawFrame();
	void IDrawFrame(XMPFrame* xmpFrame, CDrawPart* drawPart);
	virtual ~ CDECL CDrawFrame();

//----------------------------------------------------------------------------------------
// Inherited
//
public:		
	virtual void			RemoveEmbeddedFrame(FW_CProxyFrame* proxy);
	
	virtual FW_CFacet* 	NewFacet(XMPFacet* xmpFacet);

	virtual void			FocusStateChanged(XMPTypeToken focus, FW_Boolean newState);

	virtual void 			UsedShapeChanged(FW_CProxyRun* proxyRun, XMPFrame* embeddedXMPFrame);

	virtual FW_Boolean		HandleKeyDown(XMPEventData event);

//----------------------------------------------------------------------------------------
// Data Members
//
private:	
	CDrawPart*				fDrawPart;
};

#endif
