//========================================================================================
//
//	File:				DrawProxy.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWPROXY_H
#define DRAWPROXY_H

// ----- Framework Includes -----
#ifndef FWFRMING_H
#include "FWFrming.h"
#endif

#ifndef FWPROXY_H
#include "FWProxy.h"
#endif

// ----- OpenDoc Includes -----
#ifndef _SHAPE_
#include <Shape.h>
#endif

//==============================================================================
// Forward Declaration
//==============================================================================

class XMPFrame;
class CProxyShape;
class XMPTransform;
class CDrawPart;

//==============================================================================
//	 class CDrawProxyRun
//==============================================================================

class CDrawProxyRun : public FW_CProxyRun
{
//--------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
	CDrawProxyRun();
	void InitDrawProxyRun(CDrawPart* drawPart);
	virtual ~CDrawProxyRun();
	
//-------------------------------------------------------------------------------
//	 Inherited API
//
public:
	virtual void 				UsedShapeChanged(XMPFrame* xmpFrame);
	virtual FW_CBaseProxyBorder* 	NewProxyBorder();
	
	virtual void				SetSelectState(FW_Boolean state);
	virtual void 				GetFacetExternalTransform(XMPFrame* xmpFrame, XMPTransform* facetTransform);
	
//--------------------------------------------------------------------------------
//	 New API
//
public:
	void						OffsetProxyFrames(const FW_CPoint& offset);
	void						PlaceProxyFrames(const FW_CPoint& position);
	void						ResizeProxyFrames(XMPShape* newShape);
	
	void 						MoveBefore(CDrawProxyRun* before);
	void 						MoveBehind(CDrawProxyRun* behind);
	void						MoveLast();
	void						MoveFirst();

	void						SetShape(CProxyShape* shape)
									{fShape = shape;}
	CProxyShape* 				GetShape() const
									{return fShape;}
	
//--------------------------------------------------------------------------------
//	 Data Members
//--------------------------------------------------------------------------------
private:
	CProxyShape					*fShape;
	CDrawPart					*fDrawPart;
};

#endif
