//========================================================================================
//
//	File:				DrawProxyBorder.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWPROXYBORDER_H
#define DRAWPROXYBORDER_H

// ----- Framework Includes
#ifndef FWBORDER_H
#include "FWBorder.h"
#endif

//==============================================================================
// Forward Declarations
//==============================================================================

class CDrawProxyRun;
class CProxyShape;

//==============================================================================
// class CDrawProxyBorder
//==============================================================================

class CDrawProxyBorder : public FW_CBaseProxyBorder
{
public:
	CDrawProxyBorder();
	void InitDrawProxyBorder(CDrawProxyRun* proxyRun);
	virtual ~CDrawProxyBorder();

	// ----- Drawing -----
	virtual void		DrawProxyBorder(FW_CFacet* facet, XMPFacet* embeddedFacet);
	virtual void		EraseProxyBorder(FW_CFacet* facet, XMPFacet* embeddedFacet);
	
	// ----- Hit Test -----
	virtual short	WhereInProxyBorder(FW_CFacet* facet, const FW_CPoint& mouse) const;

private:
	CDrawProxyRun*		fProxyRun;
};


#endif

