//========================================================================================
//
//	File:				ToolFrame.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef TOOLFRAME_H
#define TOOLFRAME_H

#ifndef DRAWPART_H
#include "DrawPart.h"
#endif

// ----- Framework Includes -----

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

//==============================================================================
// Forward Declaration
//==============================================================================

class CDrawPart;
class FW_CFacet;
class FW_CFloatingWindow;
class XMPFrame;
class XMPWindow;

//==============================================================================
// CToolFrame
//==============================================================================

class CToolFrame : public FW_CFrame
{
//------------------------------------------------------------------------------
// Initialization/destruction
//------------------------------------------------------------------------------
public:		
	CToolFrame();
	void InitToolFrame(XMPFrame* xmpFrame, CDrawPart* drawPart);
	virtual ~ CDECL CToolFrame();

//------------------------------------------------------------------------------
// Inherited
//------------------------------------------------------------------------------
public:		
	virtual FW_CFacet* 		NewFacet(XMPFacet* xmpFacet);
	
//------------------------------------------------------------------------------
// Data Members
//------------------------------------------------------------------------------
private:	
	CDrawPart*				fDrawPart;
};

#endif
