/*
	File:		QDrawPart.r

	Contains:	NMAP resource for QDrawPart

	Written by:	Henri Lamiraux

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<5+>	 1/25/94	MB		Update NMAP resources to the
									Internationalizable format.

	To Do:
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#ifndef __STDTYPES_R__
	#include "StdTypes.r"
#endif __STDTYPES_R__

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

#ifndef _QDRAWDEF_
	#include "DrawDef.h"
#endif

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (FW_kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kDrawKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kXMPCategoryGraphics
			}
		}
	}
};

resource kNameMappings (FW_kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kCDrawPartID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kDrawKind
			}
		}
	}
};

resource kNameMappings (FW_kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kCDrawPartID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kDrawEditorUserString
		}
	}
};

resource kNameMappings (FW_kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kDrawKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kDrawKindUserString
		}
	}
};

resource kNameMappings (FW_kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kXMPCategoryGraphics,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kDrawCategoryUserString
		}
	}
};

resource kNameMappings (FW_kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kDrawKind,
		kXMPIsMacOSType {
			kDrawOSType
		}
	}
};

include "Tools.Pict" not 'ckid';
