//========================================================================================
//
//	File:				DrawProxyBorder.cpp
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef DRAWPROXYBORDER_H
#include "DrawProxyBorder.h"
#endif

#ifndef DRAWPROXY_H
#include "DrawProxy.h"
#endif

#ifndef SHAPES_H
#include "Shapes.h"
#endif

#pragma segment drawpart

//==============================================================================
// class CDrawProxyBorder
//==============================================================================

//------------------------------------------------------------------------------
// CDrawProxyBorder::CDrawProxyBorder
//------------------------------------------------------------------------------

CDrawProxyBorder::CDrawProxyBorder()
{
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::InitDrawProxyBorder
//------------------------------------------------------------------------------

void CDrawProxyBorder::InitDrawProxyBorder(CDrawProxyRun *proxyRun)
{
	InitBaseProxyBorder(proxyRun);
	fProxyRun = proxyRun;
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::~CDrawProxyBorder
//------------------------------------------------------------------------------

CDrawProxyBorder::~CDrawProxyBorder()
{
}

//------------------------------------------------------------------------------
// 	CDrawProxyBorder::DrawProxyBorder
//
// Enclosure must be prepared for drawing
//------------------------------------------------------------------------------

void CDrawProxyBorder::DrawProxyBorder(FW_CFacet* facet, XMPFacet* embeddedFacet)
{
FW_UNUSED(embeddedFacet);

	fProxyRun->GetShape()->DrawShapeHandles(facet, TRUE);
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::EraseProxyBorder
//
//	Enclosure must be prepared for drawing
//------------------------------------------------------------------------------

void CDrawProxyBorder::EraseProxyBorder(FW_CFacet* facet, XMPFacet* embeddedFacet)
{	
FW_UNUSED(embeddedFacet);

	fProxyRun->GetShape()->DrawShapeHandles(facet, FALSE);
}

//------------------------------------------------------------------------------
// CDrawProxyBorder::WhereInProxyBorder
//
//	1--5--2
//	|	  |
//	8	  6
//	|	  |
//  3--7--4
//------------------------------------------------------------------------------

short CDrawProxyBorder::WhereInProxyBorder(FW_CFacet* facet, const FW_CPoint& mouse) const
{
	return fProxyRun->GetShape()->WhichHandle(facet, mouse);
}

