//========================================================================================
//
//	File:				PaletteFrame.cpp
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef PALETTEFRAME_H
#include "PaletteFrame.h"
#endif

#ifndef DRAWPART_H
#include "DrawPart.h"
#endif

#ifndef UTILITIES_H
#include "Utilities.h"
#endif

#ifndef PALETTEDACET_H
#include "PaletteFacet.h"
#endif

#ifndef FWWINDOW_H
#include "FWWindow.h"
#endif

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(mathRoutinesIncludes)
#include <math routines.h>
#endif

#pragma segment drawpart

//=========================================================================
// CLASS CPaletteFrame
//=========================================================================

//------------------------------------------------------------------------------
// CPaletteFrame::CPaletteFrame
//------------------------------------------------------------------------------

CPaletteFrame::CPaletteFrame()
{
}

//------------------------------------------------------------------------------
// CPaletteFrame::InitPaletteFrame
//------------------------------------------------------------------------------

void CPaletteFrame::InitPaletteFrame(XMPFrame* xmpFrame, CDrawPart *drawPart)
{
	InitFrame(xmpFrame, drawPart);
	fDrawPart = drawPart;
	this->SetCanBeActiveFrame(FALSE);
}

//------------------------------------------------------------------------------
// CPaletteFrame::~CPaletteFrame
//------------------------------------------------------------------------------

CPaletteFrame::~CPaletteFrame()
{
}

//------------------------------------------------------------------------------
// CPaletteFrame::NewFacet
//------------------------------------------------------------------------------

FW_CFacet* CPaletteFrame::NewFacet(XMPFacet* xmpFacet)
{
	CPaletteFacet* facet = new CPaletteFacet;
	facet->InitPaletteFacet(xmpFacet, fDrawPart);
	return facet;
}


