//========================================================================================
//
//	File:				Templat.cpp
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

// ----- Framework Includes -----

#ifndef FWSTRS_H
#include <FWStrs.h>
#endif
#ifndef BCSTOREU_H
#include <BCStoreU.h>
#endif
#ifndef FWARDYNA_H
#include <FWArDyna.h>
#endif
#ifndef FWMATH_H
#include <FWMath.h>
#endif

#include <BCUnboun.cpp>
#include <BCDynami.cpp>
#include <BCNodes.cpp>
#include <BCHashTa.cpp>

#include <BCColl.cpp>
#include <BCCollD.cpp>
#include <BCCollU.cpp>

#include <BCMap.cpp>
#include <BCMapD.cpp>

#include <FWStrgAr.tpp>
#include <FWUtil.tpp>

#pragma template_access public

//========================================================================================
// Forward declarations
//========================================================================================

class XMPMacFacet;
class XMPFrame;

class FW_CProxyFrame;
class FW_CFrame;
class FW_CWindow;
class FW_CProxyRun;
class FW_CPublishLink;
class FW_CSubscribLink;

class CDrawPublishLink;
class CBaseShape;

//----------------------------------------------------------------------------------------
// ----- Trigger the template expansion of framework templates
//----------------------------------------------------------------------------------------

#pragma template FW_Minimum(unsigned int, unsigned int)
#pragma template FW_Minimum(long, long)

#pragma template BC_TDynamic<FW_CProxyFrame *,BC_CUnmanaged>
#pragma template BC_TCollection<FW_CProxyFrame *>
#pragma template BC_TDynamicCollection<FW_CProxyFrame *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<FW_CProxyFrame *>

#pragma template BC_TDynamic<XMPMacFacet *,BC_CUnmanaged>
#pragma template BC_TCollection<XMPMacFacet *>
#pragma template BC_TDynamicCollection<XMPMacFacet *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<XMPMacFacet *>

#pragma template BC_TDynamic<FW_CFrame *,BC_CUnmanaged>
#pragma template BC_TCollection<FW_CFrame *>
#pragma template BC_TDynamicCollection<FW_CFrame *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<FW_CFrame *>

#pragma template BC_TDynamic<FW_CWindow *,BC_CUnmanaged>
#pragma template BC_TCollection<FW_CWindow *>
#pragma template BC_TDynamicCollection<FW_CWindow *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<FW_CWindow *>

#pragma template BC_TDynamic<FW_CProxyRun *,BC_CUnmanaged>
#pragma template BC_TCollection<FW_CProxyRun *>
#pragma template BC_TDynamicCollection<FW_CProxyRun *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<FW_CProxyRun *>

#pragma template BC_TDynamic<FW_CPublishLink *,BC_CUnmanaged>
#pragma template BC_TCollection<FW_CPublishLink *>
#pragma template BC_TDynamicCollection<FW_CPublishLink *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<FW_CPublishLink *>

#pragma template BC_TCollectionActiveIterator<FW_CSubscribLink *>

// ----- Template expansion of Booch Map classes -----

#pragma template BC_TPair<FW_SPrivArcStr,FW_SPrivArcStr>
#pragma template BC_TDynamic<BC_TPair<FW_SPrivArcStr,FW_SPrivArcStr>,BC_CUnmanaged>
#pragma template BC_TTable<FW_SPrivArcStr,FW_SPrivArcStr,101,BC_TDynamic<BC_TPair<FW_SPrivArcStr,FW_SPrivArcStr>,BC_CUnmanaged>>
#pragma template BC_TMap<FW_SPrivArcStr,FW_SPrivArcStr>
#pragma template BC_TDynamicMap<FW_SPrivArcStr,FW_SPrivArcStr,101,BC_CUnmanaged>
#pragma template BC_TMapActiveIterator<FW_SPrivArcStr,FW_SPrivArcStr>

#pragma template BC_TPair<FW_SPrivArcStr,FW_SPrivArcFun>
#pragma template BC_TDynamic<BC_TPair<FW_SPrivArcStr,FW_SPrivArcFun>,BC_CUnmanaged>
#pragma template BC_TTable<FW_SPrivArcStr,FW_SPrivArcFun,101,BC_TDynamic<BC_TPair<FW_SPrivArcStr,FW_SPrivArcFun>,BC_CUnmanaged>>
#pragma template BC_TMap<FW_SPrivArcStr,FW_SPrivArcFun>
#pragma template BC_TDynamicMap<FW_SPrivArcStr,FW_SPrivArcFun,101,BC_CUnmanaged>
#pragma template BC_TMapActiveIterator<FW_SPrivArcStr,FW_SPrivArcFun>

// ----- Template expansion of String classes -----

#pragma template FW_TBoundedString<32>
#pragma template FW_TBoundedString<255>

// ----- Template expansion of Archiver classes -----

#pragma template FW_TStringArchiver<FW_TBoundedString<32>>
#pragma template FW_TStringArchiver<FW_TBoundedString<255>>
#pragma template FW_TStringArchiver<FW_CDynamicString>


//----------------------------------------------------------------------------------------
// ----- Trigger the template expansion of DrawPart templates
//----------------------------------------------------------------------------------------

#pragma template BC_TDynamic<CDrawPublishLink *,BC_CUnmanaged>
#pragma template BC_TCollection<CDrawPublishLink *>
#pragma template BC_TDynamicCollection<CDrawPublishLink *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<CDrawPublishLink *>

#pragma template BC_TDynamic<CBaseShape *,BC_CUnmanaged>
#pragma template BC_TCollection<CBaseShape *>
#pragma template BC_TDynamicCollection<CBaseShape *,BC_CUnmanaged>
#pragma template BC_TCollectionActiveIterator<CBaseShape *>

#pragma template BC_TNode<CBaseShape *, BC_CUnmanaged>
#pragma template BC_TUnbounded<CBaseShape *,BC_CUnmanaged>
#pragma template BC_TUnboundedCollection<CBaseShape *,BC_CUnmanaged>

#pragma template FW_TCollectionActiveIterator<CBaseShape *>