//========================================================================================
//
//	File:				ToolFrame.cpp
//	Release Version:	$ 1.0d1 $
//
//	Author:				Henri Lamiraux
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef TOOLFRAME_H
#include "ToolFrame.h"
#endif

#ifndef DRAWPART_H
#include "DrawPart.h"
#endif

#ifndef UTILITIES_H
#include "Utilities.h"
#endif

#ifndef TOOLDACET_H
#include "ToolFacet.h"
#endif

// ----- Framework Includes -----
#ifndef FWWINDOW_H
#include "FWWindow.h"
#endif

// ----- Macintosh Includes -----
#ifndef mathRoutinesIncludes
#include <math routines.h>
#endif

#pragma segment drawpart

//=========================================================================
// CLASS CToolFrame
//=========================================================================

//------------------------------------------------------------------------------
// CToolFrame::CToolFrame
//------------------------------------------------------------------------------

CToolFrame::CToolFrame()
{
}

//------------------------------------------------------------------------------
// CToolFrame::InitToolFrame
//------------------------------------------------------------------------------

void CToolFrame::InitToolFrame(XMPFrame* xmpFrame, CDrawPart *drawPart)
{
	InitFrame(xmpFrame, drawPart);
	fDrawPart = drawPart;
	this->SetCanBeActiveFrame(FALSE);
}

//------------------------------------------------------------------------------
// CToolFrame::~CToolFrame
//------------------------------------------------------------------------------

CToolFrame::~CToolFrame()
{
}

//------------------------------------------------------------------------------
// CToolFrame::NewFacet
//------------------------------------------------------------------------------

FW_CFacet* CToolFrame::NewFacet(XMPFacet* xmpFacet)
{
	CToolFacet* facet = new CToolFacet;
	facet->InitToolFacet(xmpFacet, fDrawPart);
	return facet;
}
