//========================================================================================
//
//	File:				MovieFra.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Lonnie Millett
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef MOVIEFRA_H
#define MOVIEFRA_H

#ifndef FWFRAME_H
#include <FWFrame.h>
#endif

#if defined(FW_BUILD_MAC) && !defined(__MOVIES__)
#include <Movies.h>
#endif

#if defined(FW_BUILD_MAC) && !defined(__ALIASES__)
#include <Aliases.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================

class CMovieFrame;

//==============================================================================
// Classes used by this interface
//==============================================================================

class CMoviePart;
class FW_CFacet;
class XMPFrame;
class XMPShape;
class XMPMacMenuBar;

//==============================================================================
// CMovieFrame
//==============================================================================

class CMovieFrame : public FW_CFrame
{
public:
	CMovieFrame();
	void InitMovieFrame(XMPFrame* xmpFrame, CMoviePart* moviePart);
	virtual ~ CDECL CMovieFrame();
	
	CMoviePart* GetMoviePart() const;
	
	FW_CFacet* NewFacet(XMPFacet* xmpFacet);
	virtual void FacetAdded(FW_CFacet* facet);
	virtual XMPWindow*  CreateChildWindow(XMPISOStr windowTitle);

	virtual void FrameShapeChanged();
	
	virtual void FocusStateChanged(XMPTypeToken focus, FW_Boolean newState);

	virtual FW_Boolean HandleKeyDown(XMPEventData event);
	virtual FW_Boolean DoMenuEvent(XMPMenuBar *menuBar, XMPCommandID commandID);
	virtual void  DoAdjustMenus(XMPMenuBar* menuBar);	
	
	void UpdateMovie();
	void AdjustFrameSize(const FW_CRect& movieBox);
	
	void SetNewMovie(Movie newMovie);
	
	//----- Selection -------
	void CloseSelection();
	void ClearSelection(TimeValue currentTime, TimeValue duration);
	void SelectAll();
	void PasteMovieToSelection(Movie newMovie, TimeValue currentTime, TimeValue duration);
	void PasteHandleToSelection(FW_PlatformHandle newHandle, OSType handleType, TimeValue currentTime, TimeValue duration);

	void ToggleLooping(FW_Boolean looping);

private:
	CMoviePart* fMoviePart;
};

//----------------------------------------------------------------------------------------
// CMovieFrame::GetMoviePart
//----------------------------------------------------------------------------------------
inline CMoviePart* CMovieFrame::GetMoviePart() const
{
	return fMoviePart;
}

#endif
