//========================================================================================
//
//	File:							MovieSel.h
//	Release Version:	$ 1.0d1 $
//
//	Author:						Lonnie Millett
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef MOVIESEL_H
#define MOVIESEL_H

// ----- FrameWork Includes -----

#ifndef FWSELECT_H
#include <FWSelect.h>
#endif

//==============================================================================
//	 Forward Declarations
//==============================================================================

class CMoviePart;
class CDrawFrame;
class FW_CFacet;
class CSelectionIterator;

//==============================================================================
//	 class CMovieSelection
//==============================================================================

class CMovieSelection : public FW_CSelection
{
	
//------------------------------------------------------------------------------
//	 Initialization/Destruction
//------------------------------------------------------------------------------
public:
	CMovieSelection();
	void			InitMovieSelection(CMoviePart* moviePart);
	virtual 		~CMovieSelection();
	
//------------------------------------------------------------------------------
//	 Inherited API
//------------------------------------------------------------------------------
public:
	virtual void		CloseSelection();
	virtual void		SelectAll();
	virtual FW_Boolean	IsEmpty() const;

	// ----- Cut/Copy/Paste/Clear -----
	virtual FW_Boolean	DoClear();
	
	virtual void		ExternalizeSelection(XMPStorageUnit* storageUnit, FW_CFrame* commandFrame, XMPCloneKind cloneKind);
	virtual FW_Boolean	InternalizeSelection(XMPStorageUnit* storageUnit, XMPCloneKind cloneKind);
	void PasteOSTypeToMovies(FW_PlatformHandle newHandle, OSType handleType);

//------------------------------------------------------------------------------
//	 Data Members
//------------------------------------------------------------------------------
private:
	CMoviePart*			fMoviePart;
};

#endif