//	File:		MoviePar.r
//
//	Contains:	Resources for CMoviePart
//
//	Written by:	Lonnie Millett
//
//	Copyright:	 1993-1994 by Apple Computer, Inc., all rights reserved.

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"
#include "SysTypes.r"
#include "StdTypes.r"
#include "StdDefs.h"
#include "MovieDef.h"

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (FW_kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleMovieKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kXMPCategoryVideo
			}
		}
	}
};

resource kNameMappings (FW_kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kCMoviePartID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kSampleMovieKind
			}
		}
	}
};

resource kNameMappings (FW_kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kCMoviePartID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleMovieEditorUserString
		}
	}
};

resource kNameMappings (FW_kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleMovieKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleMovieKindUserString
		}
	}
};

resource kNameMappings (FW_kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kXMPCategoryVideo,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleMovieCategoryUserString
		}
	}
};

resource kNameMappings (FW_kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kSampleMovieKind,
		kXMPIsMacOSType {
			kSampleMovieOSType
		}
	}
};

resource 'MENU' (kMovieMenu, preload) {
	kMovieMenu, textMenuProc,
	0b1111111111111111111111111111111,
	enabled, "Movie",
	{
		"Choose Movie",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Start Movie",
			noicon, nokey, nomark, plain;
		"Stop Movie",
			noicon, nokey, nomark, plain;
		"-",
			noicon, nokey, nomark, plain;
		"Looping",
			noicon, nokey, nomark, plain;
	}
};

include "Image.Pict" not 'ckid';
