/*
	File:		SndPart.r

	Contains:	NMAP resource for SndPart

	Written by:	Lonnie Millett

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<2+>	 1/25/94	MB		Update NMAP resources to the
									Internationalizable format.

	To Do:
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#ifndef __STDTYPES_R__
	#include "StdTypes.r"
#endif __STDTYPES_R__

#ifndef _STDDEFS_
	#include "StdDefs.h"
#endif _STDDEFS_

#ifndef _SNDPARTDEF_
	#include "SndPartDef.h"
#endif

//-------------------------------------------------------------------------------------
// NMAP Resources
//-------------------------------------------------------------------------------------

resource kNameMappings (FW_kKindCategoryMapId) {
	kXMPKind,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleSndKind,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kXMPCategorySound
			}
		}
	}
};

resource kNameMappings (FW_kEditorKindMapId) {
	kXMPEditorKinds,
	{	/* array Types: 1 elements */
		/* [1] */
		kCSndPartID,
		kXMPIsAnISOStringList
		{
			{	/* array ClassIDs: 1 elements */
				/* [1] */
				kSampleSndKind
			}
		}
	}
};

resource kNameMappings (FW_kEditorUserStringMapId) {
	kXMPEditorUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kCSndPartID,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleSndEditorUserString
		}
	}
};

resource kNameMappings (FW_kKindUserStringMapId) {
	kXMPKindUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kSampleSndKind,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleSndKindUserString
		}
	}
};

resource kNameMappings (FW_kCategoryUserStringMapId) {
	kXMPCategoryUserString,
	{	/* array Types: 1 elements */
		/* [1] */
		kXMPCategorySound,
		kXMPIsINTLText
		{
			kXMPRomanScript,
			kXMPEnglishLang,
			kSampleSndCategoryUserString
		}
	}
};

resource kNameMappings (FW_kOldMacOSTypeMapId) {
	kXMPKindOldMacOSType,
	{	/* array KeyList: 1 elements */
		/* [1] */
		kSampleSndKind,
		kXMPIsMacOSType {
			kSampleSndOSType
		}
	}
};
