//========================================================================================
//
//	File:				TextFrame.h
//	Release Version:	$ 1.0d1 $
//
//	Author:				Anthone Burbidge
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef _TEXTFRAME_
#define _TEXTFRAME_

#ifndef FWFRMING_H
#include "FWFrming.h"
#endif

// ----- Platform Includes -----

#ifndef __TEXTEDIT__
#include "TextEdit.h"
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class CTextPart;
class CTextFacet;
class CRulerFrame;


//========================================================================================
// CTextFrame
//========================================================================================

class CTextFrame : public FW_CEmbeddingFrame
{
// ----- Initialization/destruction
public:		
	CTextFrame();
	void ITextFrame(XMPFrame* xmpFrame, CTextPart* textPart);
	virtual ~ CDECL CTextFrame();

// ----- From FW_CFrame
public:		
	virtual FW_Boolean		HandleKeyDown(XMPEventData event);
	virtual FW_Boolean		DoIdle();
	virtual void			FrameShapeChanged();
	virtual void			FocusStateChanged(XMPTypeToken focus, FW_Boolean newState);
	virtual FW_CFacet*			NewFacet(XMPFacet* xmpFacet);
	virtual FW_Boolean		DoMenuEvent(XMPMenuBar *menuBar, XMPCommandID commandID);
	virtual void 			FacetAdded(FW_CFacet* facet);
	virtual void 			FacetRemoved(FW_CFacet* facet);
	
// ----- New Methods
public:
	XMPFrame*				GetRulerFrame()
								{ return fRulerFrame; }

protected:
	virtual void			ShowRuler();
	virtual void			HideRuler();
	
private:
	void					GrowFrame();
	void					SetFontSize(short fontSize);

// ----- Constants
public:
	enum { kBorderInset = 4 };
	
// ----- Data Members
private:	
	CTextPart*				fTextPart;
	XMPFrame*				fRulerFrame;
};

#endif
