//========================================================================================
//
//	File:							TextProxy.h
//	Release Version:	$ 1.0d1 $
//
//	Author:						Anthone Burbidge
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef _TEXTPROXY_
#define _TEXTPROXY_

// ----- Framework Includes -----

#ifndef FWPROXY_H
#include "FWProxy.h"
#endif

//==============================================================================
// Forward class declarations
//==============================================================================

class XMPPart;
class XMPFrame;
class XMPTransform;
class FW_CEmbeddingPart;
class CTextPart;


//==============================================================================
// CLASS CTextProxyRun
//==============================================================================

class CTextProxyRun : public FW_CProxyRun
{
// ----- Construct/destruct/initialize
public:
	CTextProxyRun();
	void InitTextProxyRun(FW_CEmbeddingPart* embeddingPart);
	virtual ~CTextProxyRun();

// ----- from FW_CProxyRun
public:
	virtual void UsedShapeChanged(XMPFrame* xmpFrame);
	virtual void GetFacetExternalTransform(XMPFrame* xmpFrame,
										   XMPTransform* facetTransform);
	virtual void SetSelectState(FW_Boolean state);

// ----- New methods and fields
public:
	void		SetBoundingBox(const FW_SPlatformRect& rect);
	void		GetBoundingBox(FW_SPlatformRect& rect) const;
	
private:
	FW_SPlatformRect		fBoundingBox;
};

#endif
