//========================================================================================
//
//	File:							RulerFrame.cpp
//	Release Version:	$ 1.0d1 $
//
//	Author:						Anthone Burbidge
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef _TEXTPART_
#include "TextPart.h"
#endif

#ifndef _RULERFRAME_
#include "RulerFrame.h"
#endif

#ifndef _RULERFACET_
#include "RulerFacet.h"
#endif

#pragma segment TextPartSegment


//========================================================================================
// CLASS CRulerFrame
//========================================================================================

//----------------------------------------------------------------------------------------
// CRulerFrame::CRulerFrame
//----------------------------------------------------------------------------------------

CRulerFrame::CRulerFrame() :
	FW_CFrame(),
	fTextPart(NULL)
{
}

//----------------------------------------------------------------------------------------
// CRulerFrame::CRulerFrame
//----------------------------------------------------------------------------------------

void CRulerFrame::IRulerFrame(XMPFrame* xmpFrame, CTextPart* textPart)
{
	InitFrame(xmpFrame, textPart);
	SetFrontClicks(TRUE);
	fTextPart = textPart;
}

//----------------------------------------------------------------------------------------
// CRulerFrame::~CRulerFrame
//----------------------------------------------------------------------------------------

CRulerFrame::~CRulerFrame()
{
}

//----------------------------------------------------------------------------------------
// CRulerFrame::FocusStateChanged
//----------------------------------------------------------------------------------------

void CRulerFrame::FocusStateChanged(XMPTypeToken focus, FW_Boolean newState)
{
	FW_CFrame::FocusStateChanged(focus, newState);
}

//----------------------------------------------------------------------------------------
// CRulerFrame::NewFacet
//----------------------------------------------------------------------------------------

FW_CFacet* CRulerFrame::NewFacet(XMPFacet* xmpFacet)
{
	CRulerFacet* facet = new CRulerFacet;
	facet->IRulerFacet(xmpFacet, fTextPart);
	return facet;
}

