/*
	File:		OffScreen.h

	Contains:	xxx put contents here xxx

	Written by:	Essam Zaky

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	  1/4/94	EZ		clean up
		 <1>	  1/4/94	EZ		first checked in

*/

#ifndef _OffScreen_
#define _OffScreen_

#ifndef _ToolBoxDump_
#include "ToolBoxDump.h"
#endif

#ifndef __QDOFFSCREEN__
#include <QDOffscreen.h>
#endif
//***************************************************************************************************

#if defined(applec) && !defined(__SC__)
class	COffScreen : private SingleObject {
#else
class	COffScreen {
#endif
public:
//-----
	COffScreen() {}
	
	void IOffScreen();
	
	void Free();
	
	Boolean BeginOffScreen(const Rect* onScrRect);

	void EndOffScreen(); //should be called only if BeginOffScreen returns true
	
	void PurgeOffScreen(); //mark the off screen as unlocked and purgeable
	
private:
//------
	CGrafPtr 	fOnScreenPort;
	GDHandle 	fOnScreenDev;
	GWorldPtr fOffScrWorld;
	PixMapHandle fOffScrPixMap;
	Boolean fOffScreenLocked;
	
	//in system 7, RGB color Get, Set are present
	#ifndef txtnSys7
	Boolean fColoredPort;

	long fOnScreenForeColor;
	long fOnScreenBackColor;
	#endif
	
	RGBColor fOnScreenForeRGB;
	RGBColor fOnScreenBackRGB;

	Rect			fOnScrRect;

	short			fOffScrHite;
	short			fOffScrWidth;
	
	short fSumWidth;
	short fSumHite;
	short fAverageCount;
	
	#ifdef txtnDebug
	char fInUse;
	#endif
	
	Boolean NewOffScrWorld(short width, short hite);
	Boolean UpdateOffScrWorld(short width, short hite);
	
	void ResetAverage();
};
//**************************************************************************************************


#endif
