/*
	File:		Paragraph.h

	Contains:	xxx put contents here xxx

	Written by:	Essam Zaky

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	  1/4/94	EZ		clean up
		 <1>	  1/4/94	EZ		first checked in

*/

#ifndef _Paragraph_
#define _Paragraph_

#ifndef _ToolBoxDump_
#include "ToolBoxDump.h"
#endif

#ifndef _TextensionCommon_
#include "TextensionCommon.h"
#endif

//***************************************************************************************************

const short kMaxParagCtrlChars = 500; //allocate global data of size kMaxParagCtrlChars*3

class CParagCtrlChars : private SingleObject {
	public :
		CParagCtrlChars() {}
		
		void Invalid();
		
		long Define(uPtr charsPtr, long startOffset, long maxOffset);
		
		inline long GetParagEnd() {return fParagEnd;}
		inline long GetParagStart() {return fParagStart;}
		
		long GetCurrCtrlOffset();
		char GetCurrCtrlChar();
		
		inline void Next() {++fIndex;}
		
		inline void Reset() {fIndex = 0;}
		
	private:
		long fParagStart;
		long fParagEnd;
		
		short fCount;
		short fOffsets[kMaxParagCtrlChars];
		char	fChars[kMaxParagCtrlChars];

		short fIndex; //for iteration
};



extern CParagCtrlChars gParagCtrlChars;
//***************************************************************************************************

long GetParagStartOffset(uPtr charsPtr, long lenBefore);

long GetParagEndOffset(uPtr charsPtr, long lenAfter);

#endif
