//  The C++ Booch Components (Version 2.1)
//  (C) Copyright 1990-1993 Grady Booch. All Rights Reserved.
//
//  Restricted Rights Legend
//  Use, duplication, or disclosure is subject to restrictions as set forth 
//  in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
//  Software clause at DFARS 252.227-7013. 
//
//  BCOCol.cpp
//
//  This file contains the definitions for the ordered collection abstract base class.

#include "BCExcept.h"
#include "BCOCol.h"

template<class Item>
BC_TOrderedCollection<Item>::BC_TOrderedCollection()
  : fOrder(0) {}

template<class Item>
BC_TOrderedCollection<Item>::BC_TOrderedCollection(BC_Index (*order)(const Item&))
  : fOrder(order) {}

template<class Item>
BC_TOrderedCollection<Item>::BC_TOrderedCollection(const BC_TOrderedCollection<Item>& c)
  : fOrder(c.fOrder) {}

template<class Item>
BC_TOrderedCollection<Item>::~BC_TOrderedCollection() {}

template<class Item>
void BC_TOrderedCollection<Item>::SetOrderFunction(BC_Index (*order)(const Item&))
{
  BC_Assert((!fOrder),
            BC_XDuplicate("BC_TOrderedCollection::SetOrderFunction", BC_kDuplicate));
  fOrder = order;
}
