//  The C++ Booch Components (Version 2.1)
//  (C) Copyright 1990-1993 Grady Booch. All Rights Reserved.
//
//  BCOColU.h
//
//  This file contains the declaration of the unbounded ordered collection.

#ifndef BCOCOLU_H
#define BCOCOLU_H 1

#include "BCUnboun.h"
#include "BCOCol.h"

// Unbounded ordered collection

template<class Item, class StorageManager>
class BC_TUnboundedOrderedCollection : public BC_TOrderedCollection<Item> {
public:

  BC_TUnboundedOrderedCollection();
  BC_TUnboundedOrderedCollection
    (const BC_TUnboundedOrderedCollection<Item, StorageManager>&);
  virtual ~BC_TUnboundedOrderedCollection();

  virtual BC_TCollection<Item>& operator=(const BC_TCollection<Item>&);
  virtual BC_TCollection<Item>& 
    operator=(const BC_TUnboundedOrderedCollection<Item, StorageManager>&);
  virtual BC_Boolean operator==(const BC_TCollection<Item>&) const;
  virtual BC_Boolean
    operator==(const BC_TUnboundedOrderedCollection<Item, StorageManager>&) const;
  BC_Boolean
    operator!=(const BC_TUnboundedOrderedCollection<Item, StorageManager>&) const;
  virtual const Item& operator[](BC_Index) const;
  virtual Item& operator[](BC_Index);

  virtual void Clear();
  virtual void Insert(const Item&);
  virtual void Insert(const Item&, BC_Index before);
  virtual void Append(const Item&);
  virtual void Append(const Item&, BC_Index after);
  virtual void Remove(BC_Index at);
  virtual void Replace(BC_Index at, const Item&);

  virtual BC_Index Length() const;
  virtual BC_Boolean IsEmpty() const;
  virtual const Item& First() const;
  virtual Item& First();
  virtual const Item& Last() const;
  virtual Item& Last();
  virtual BC_ExtendedIndex Location(const Item&) const;

  static void* operator new(size_t);
  static void operator delete(void*, size_t);

protected:

  BC_TUnbounded<Item, StorageManager> fRep;

  virtual void Purge();
  virtual void Add(const Item&);
  virtual BC_Index Cardinality() const;
  virtual const Item& ItemAt(BC_Index) const;

};

#endif
