//  The C++ Booch Components (Version 2.1)
//  (C) Copyright 1990-1993 Grady Booch. All Rights Reserved.
//
//  BCQueU.h
//
//  This file contains the declaration of the unbounded queue.

#ifndef BCQUEU_H
#define BCQUEU_H 1

#include "BCUnboun.h"
#include "BCQue.h"

// Unbounded queue

template<class Item, class StorageManager>
class BC_TUnboundedQueue : public BC_TQueue<Item> {
public:

  BC_TUnboundedQueue();
  BC_TUnboundedQueue(const BC_TUnboundedQueue<Item, StorageManager>&);
  virtual ~BC_TUnboundedQueue();

  virtual BC_TQueue<Item>& operator=(const BC_TQueue<Item>&);
  virtual BC_TQueue<Item>& operator=(const BC_TUnboundedQueue<Item, StorageManager>&);
  virtual BC_Boolean operator==(const BC_TQueue<Item>&) const;
  virtual BC_Boolean operator==(const BC_TUnboundedQueue<Item, StorageManager>&) const;
  BC_Boolean operator!=(const BC_TUnboundedQueue<Item, StorageManager>&) const;

  virtual void Clear();
  virtual void Append(const Item&);
  virtual void Pop();
  virtual void Remove(BC_Index at);

  virtual BC_Index Length() const;
  virtual BC_Boolean IsEmpty() const;
  virtual const Item& Front() const;
  virtual Item& Front();
  virtual BC_ExtendedIndex Location(const Item&) const;

  static void* operator new(size_t);
  static void operator delete(void*, size_t);

protected:

  BC_TUnbounded<Item, StorageManager> fRep;
  
  virtual void Purge();
  virtual void Add(const Item&);
  virtual BC_Index Cardinality() const;
  virtual const Item& ItemAt(BC_Index) const;
  
};

#endif
