//  The C++ Booch Components (Version 2.1)
//  (C) Copyright 1990-1993 Grady Booch. All Rights Reserved.
//
//  BCStacD.h
//
//  This file contains the declaration of the dynamic stack.

#ifndef BCSTACD_H
#define BCSTACD_H 1

#include "BCDynami.h"
#include "BCStac.h"

// Dynamic stack

template<class Item, class StorageManager>
class BC_TDynamicStack : public BC_TStack<Item> {
public:

  BC_TDynamicStack();
  BC_TDynamicStack(BC_Index ChunkSize);
  BC_TDynamicStack(const BC_TDynamicStack<Item, StorageManager>&);
  virtual ~BC_TDynamicStack();

  virtual BC_TStack<Item>& operator=(const BC_TStack<Item>&);
  virtual BC_TStack<Item>& operator=(const BC_TDynamicStack<Item, StorageManager>&);
  virtual BC_Boolean operator==(const BC_TStack<Item>&) const;
  virtual BC_Boolean operator==(const BC_TDynamicStack<Item, StorageManager>&) const;
  BC_Boolean operator!=(const BC_TDynamicStack<Item, StorageManager>&) const;

  virtual void SetChunkSize(BC_Index ChunkSize);
  virtual void Preallocate(BC_Index new_length);
  virtual void Clear();
  virtual void Push(const Item&);
  virtual void Pop();
    
  virtual BC_Index ChunkSize() const;
  virtual BC_Index Depth() const;
  virtual BC_Boolean IsEmpty() const;
  virtual const Item& Top() const;
  virtual Item& Top();

  static void* operator new(size_t);
  static void operator delete(void*, size_t);

protected:

  BC_TDynamic<Item, StorageManager> fRep;  

  virtual void Purge();
  virtual void Add(const Item&);
  virtual BC_Index Cardinality() const;
  virtual const Item& ItemAt(BC_Index) const;

};

#endif
