//  The C++ Booch Components (Version 2.1)
//  (C) Copyright 1990-1993 Grady Booch. All Rights Reserved.
//
//  Restricted Rights Legend
//  Use, duplication, or disclosure is subject to restrictions as set forth 
//  in subdivision (c)(1)(ii) of the Rights in Technical Data and Computer 
//  Software clause at DFARS 252.227-7013. 
//
//  BCNodes.cpp
//
//  This file contains the definition for various node classes.

#include "BCExcept.h"
#include "BCNodes.h"

template<class Item, class Value>
BC_TPair<Item, Value>::BC_TPair() {}

template<class Item, class StorageManager>
void* BC_TNode<Item, StorageManager>::operator new(size_t s)
{
  return StorageManager::Allocate(s);
}

template<class Item, class StorageManager>
void BC_TNode<Item, StorageManager>::operator delete(void* p, size_t s)
{
  StorageManager::Deallocate(p, s);
}

template<class Item, class StorageManager>
BC_TBinaryNode<Item, StorageManager>::~BC_TBinaryNode()
{
  BC_Assert((fCount == 1),
            BC_XStorageError("BC_TBinaryNode::~BC_TBinaryNode", BC_kReferenced));
}

template<class Item, class StorageManager>
void* BC_TBinaryNode<Item, StorageManager>::operator new(size_t s)
{
  return StorageManager::Allocate(s);
}

template<class Item, class StorageManager>
void BC_TBinaryNode<Item, StorageManager>::operator delete(void* p, size_t s)
{
  StorageManager::Deallocate(p, s);
}
