//========================================================================================
//
//	File:				FWRCDefi.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/25/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWRCDEFI_H
#define FWRCDEFI_H

/****************************************/
/* Stuff that really belongs in FWRCDefi.H */
/****************************************/

/* OPF target platforms */
#define RCPF_NONE -1
#define RCPF_MAC   0
#define RCPF_OS2   1
#define RCPF_WIN   2

/*******************************************************************/
/* Stuff that is private between the OPF resource compiler and */
/* a OPF resource file (that is, a .R file). This information  */
/* is not defined to a OPF part.                        		   */
/*******************************************************************/

#if defined __PLATFORM__  || !defined OPF_INCLUDED

   /* these are the predefined types of resources */
   #define NOKIND     (-1)
   #define ACCELTABLE 1
   #define ICON 2
   #define BITMAP 3
   #define CURSOR 4
   #define CODEPAGE 5
#ifdef OBSOLETE
   #define DLG 6
   #define DIALOG 6
   #define FONT 7
   #define FRAME 8
#endif
   #define MENU 9
   #define MSGTABLE 10
   #define STRTABLE 11
   #define CUSTOMTYPE 12
   #define MULTISTRING 13

   /* these are the load and memory option values */
   #define PRELOAD 1
   #define LOADONCALL 0
   #define STATIC 2
   #define RELOCATABLE 0
   #define PURGEABLE 4
   
#ifdef FW_BUILD_WIN
   /* accelerator table stuff */
   #undef  BEDAT_SHIFT
   #define BEDAT_SHIFT 1
   #undef  BEDAT_ALT
   #define BEDAT_ALT 2
   #undef  BEDAT_OPTION
   #define BEDAT_OPTION 4
   #undef  BEDAT_CONTROL
   #define BEDAT_CONTROL 8
   #undef  BEDAT_APPLE
   #define BEDAT_APPLE 16
   #undef  BEDAT_CHAR
   #define BEDAT_CHAR 128
   #undef  BEDAT_VIRTUALKEY
   #define BEDAT_VIRTUALKEY 32
   #undef  BEDAT_SCANCODE
   #define BEDAT_SCANCODE 64
   #undef  BEDAT_CVS
   #define BEDAT_CVS (BEDAT_CHAR | BEDAT_VIRTUALKEY | BEDAT_SCANCODE)
   #undef  BEDAT_COMMAND
   #define BEDAT_COMMAND 0
   #undef  BEDAT_SYSCOMMAND
   #define BEDAT_SYSCOMMAND 256
   #undef  BEDAT_HELP
   #define BEDAT_HELP 512
   #undef  BEDAT_HS
   #define BEDAT_HS (BEDAT_SYSCOMMAND | BEDAT_HELP)
#endif

#ifdef FW_BUILD_WIN

/* Virtual keycodesWhat to do with these?*/

#ifndef VK_F1
#define VK_F1 0x70
#endif
#ifndef VK_LBUTTON
#define VK_LBUTTON 0x01
#endif
#ifndef VK_TAB
#define VK_TAB 0x09
#endif
#define BEDVK_ALT					0x12
#define BEDVK_APPLE					BEDVK_ALT
#define BEDVK_OPTION				BEDVK_ALT
#define BEDVK_BREAK					0x00
#define BEDVK_BUTTON1				VK_LBUTTON
#define BEDVK_BUTTON2				(VK_LBUTTON + 3)
#define BEDVK_BUTTON3				(VK_LBUTTON + 1)
#define BEDVK_CAPSLOCK				0x00				/* we get no msg for this */
#define BEDVK_TAB					VK_TAB
#define BEDVK_RETURN				(VK_TAB + 2)
#define BEDVK_CLEAR					(VK_TAB + 3)
#define BEDVK_ENTER					(VK_TAB + 4)
#define BEDVK_SHIFT					(VK_TAB + 7)
#define BEDVK_CONTROL				(VK_TAB + 8)
#define BEDVK_PAUSE					(VK_TAB + 10)
#define BEDVK_ESCAPE				(VK_TAB + 18)
#define BEDVK_PAGEUP				(VK_TAB + 24)
#define BEDVK_PAGEDOWN				(VK_TAB + 25)
#define BEDVK_END					(VK_TAB + 26)
#define BEDVK_HOME					(VK_TAB + 27)
#define BEDVK_LEFT					(VK_TAB + 28)
#define BEDVK_UP					(VK_TAB + 29)
#define BEDVK_RIGHT					(VK_TAB + 30)
#define BEDVK_DOWN					(VK_TAB + 31)
#define BEDVK_PAGELEFT
#define BEDVK_PAGERIGHT
#define BEDVK_PRINTSCREEN			(VK_TAB + 33)
#define BEDVK_INSERT				(VK_TAB + 36)
#define BEDVK_DELETE				(VK_TAB + 37)
#define BEDVK_HELP					(VK_TAB + 38)
#define BEDVK_NUMBERLOCK			0x90
#define BEDVK_SCROLLLOCK			(BEDVK_NUMBERLOCK + 1)

#define BEDVK_F1					VK_F1
#define BEDVK_F2					(VK_F1+1)
#define BEDVK_F3					(VK_F1+2)
#define BEDVK_F4					(VK_F1+3)
#define BEDVK_F5					(VK_F1+4)
#define BEDVK_F6					(VK_F1+5)
#define BEDVK_F7					(VK_F1+6)
#define BEDVK_F8					(VK_F1+7)
#define BEDVK_F9					(VK_F1+8)
#define BEDVK_F10					(VK_F1+9)
#define BEDVK_F11					(VK_F1+10)
#define BEDVK_F12					(VK_F1+11)
#define BEDVK_F13					(VK_F1+12)
#define BEDVK_F14					(VK_F1+13)
#define BEDVK_F15					(VK_F1+14)
#endif

#endif


#endif
