//========================================================================================
//
//	File:				FWStdDef.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/25/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSTDDEF_H
#define FWSTDDEF_H

#ifdef __cplusplus
  extern "C" {
#endif

/*========================================================================================
/  Macro definitions
/
/	The macro FW_SHARED_DATA should only be used for placement.  OPF is built with
/	model large, so pointers are always far by default.  However, static data in DLLs
/	must still have the __far keyword in order to be accessible across DLLs.
/========================================================================================*/

#ifdef FW_BUILD_MAC
#define FW_SHARED_DATA
#endif

#ifdef FW_BUILD_WIN
#if defined(FW_BUILD_WIN32S) || defined(FW_BUILD_WIN32NT)
#define FW_SHARED_DATA
#else
#define FW_SHARED_DATA __far
#endif
#endif

/*========================================================================================
/  Type definitions
/========================================================================================*/

typedef unsigned char FW_Boolean;

#ifdef FW_BUILD_MAC
typedef char** FW_PlatformHandle;
#endif

#ifdef FW_BUILD_WIN16
typedef unsigned FW_PlatformHandle;
#endif

#ifdef FW_BUILD_WIN32S
typedef void* FW_PlatformHandle;
#endif

#ifdef FW_BUILD_MAC
typedef unsigned long FW_ResourceType;
#endif

#ifdef FW_BUILD_WIN
typedef unsigned short FW_ResourceType;
#endif

typedef unsigned short FW_ResourceId;

typedef unsigned short FW_Milliseconds;

typedef double FW_Float;

/*========================================================================================
/  Constants
/========================================================================================*/

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#ifndef NULL
#define NULL 0
#endif

/*========================================================================================
/  Macros
/========================================================================================*/

#define FW_UNUSED(x)	((void) &x)

#ifdef __cplusplus
   }
#endif

#endif

