//========================================================================================
//
//	File:				FWPriStr.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/25/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRISTR_H
#include "FWPriStr.h"
#endif

#ifdef FW_BUILD_MAC
#include <Memory.h>
#endif


//----------------------------------------------------------------------------------------
// FW_PrimitiveStringLength
//----------------------------------------------------------------------------------------

size_t FW_PrimitiveStringLength(const char * p)
{
	size_t i = 0;
	for (; *p; p++, i++) ;

	return i;
}

//----------------------------------------------------------------------------------------
// FW_PrimitiveStringEqual
//----------------------------------------------------------------------------------------

int FW_PrimitiveStringEqual(const char *p1, const char *p2)
{
	while (1)
	{
		char c1 = *p1++;
		char c2 = *p2++;
		
		if (c1 != c2) return 0;
		
		if (!c1) return 1;
	}
}

//----------------------------------------------------------------------------------------
// FW_PrimitiveStringCopy
//----------------------------------------------------------------------------------------

char * FW_PrimitiveStringCopy(char *destination, char *source)
{
	char c;
	
	while ((c = *source++) != 0)
		*destination++ = c;
		
	return source;
}

//----------------------------------------------------------------------------------------
// FW_PrimitiveStringFindCharacter
//----------------------------------------------------------------------------------------

char * FW_PrimitiveStringFindCharacter(const char *source, char c)
{
	while (1)
	{
		char cc;
		if (c == (cc = *source))
		{
			return (char *) source;
		}
		else if (!cc)
		{
			return NULL;
		}
		else
			source++;
	}
}
