//========================================================================================
//
//	File:				FWPriExc.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRIEXC_H
#define FWPRIEXC_H

#ifndef   FWEXCEPT_H
#include "FWExcept.h"
#endif


enum FW_PlatformErrorAvailability
{
	kPlatformErrorNotAvailable, kPlatformErrorAvailable
};

typedef unsigned long PlatformError;

//========================================================================================
//	CLASS FW_XPrivException
//========================================================================================

class FW_XPrivException : public _FW_CException
{
public:
	FW_PlatformErrorAvailability GetPlatformErrorAvailability() const;
	PlatformError GetPlatformError() const;

	_FW_EXCEPTION_DEFINE(FW_XPrivException)
protected:
	FW_XPrivException();
	FW_XPrivException(const FW_XPrivException& exception);
	FW_XPrivException(PlatformError theError);

	virtual~ FW_XPrivException();

private:
	const FW_PlatformErrorAvailability fPlatformErrorAvailability;
	const PlatformError fPlatformError;
};

//----------------------------------------------------------------------------------------
// FW_XPrivException::GetPlatformErrorAvailability
//----------------------------------------------------------------------------------------

inline FW_PlatformErrorAvailability FW_XPrivException::GetPlatformErrorAvailability() const
{
	return fPlatformErrorAvailability;
}

#endif
