//========================================================================================
//
//	File:				FWPriExc.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWPRIEXC_H
#include "FWPriExc.h"
#endif

#ifndef FWPRIDEB_H
#include "FWPriDeb.h"
#endif

#ifdef FW_BUILD_MAC
#pragma segment BEL
#endif

//========================================================================================
// CLASS FW_XPrivException
//========================================================================================

_FW_EXCEPTION_IMPLEMENT(FW_XPrivException, _FW_CException)

//----------------------------------------------------------------------------------------
//	FW_XPrivException::FW_XPrivException
//----------------------------------------------------------------------------------------

FW_XPrivException::FW_XPrivException() :
	_FW_CException(),
	fPlatformErrorAvailability(kPlatformErrorNotAvailable),
	fPlatformError(0)
{
}

//----------------------------------------------------------------------------------------
//	FW_XPrivException::FW_XPrivException
//----------------------------------------------------------------------------------------

FW_XPrivException::FW_XPrivException(const FW_XPrivException& exception) :
	_FW_CException(),
	fPlatformErrorAvailability(exception.fPlatformErrorAvailability),
	fPlatformError(exception.fPlatformError)
{
}

//----------------------------------------------------------------------------------------
//	FW_XPrivException::FW_XPrivException
//----------------------------------------------------------------------------------------

FW_XPrivException::FW_XPrivException(PlatformError theError) :
	_FW_CException(),
	fPlatformErrorAvailability(kPlatformErrorAvailable),
	fPlatformError(theError)
{
}

//----------------------------------------------------------------------------------------
//	FW_XPrivException::GetPlatformError
//----------------------------------------------------------------------------------------

PlatformError FW_XPrivException::GetPlatformError(void) const
{
	FW_PRIV_ASSERT(fPlatformErrorAvailability == kPlatformErrorNotAvailable);
	return fPlatformError;
}

//----------------------------------------------------------------------------------------
//	FW_XPrivException::~FW_XPrivException
//----------------------------------------------------------------------------------------

FW_XPrivException::~FW_XPrivException()
{
}
