//========================================================================================
//
//	File:				FWSUStrm.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		4/12/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSUSTRM_H
#define FWSUSTRM_H

#ifndef FWASINKS_H
#include "FWASinks.h"
#endif

// ----- OpenDoc Includes -----

#ifndef _STORAGEU_
#include <StorageU.h>
#endif


//========================================================================================
//	 CLASS FW_CStorageUnitSink
//========================================================================================

class FW_CStorageUnitSink : public FW_CRandomAccessSink
{

public:

	FW_CStorageUnitSink(XMPStorageUnit* storageUnit);
	virtual ~FW_CStorageUnitSink();
	
	virtual void Read(void * destination, long count);
	virtual void ReadPeekAdvance(long bytesRead);
	
	virtual long GetWritableBytes() const;
	virtual void Write(const void* source, long count);
	virtual void WritePeekAdvance(long bytesWritten);

	virtual long GetLength() const;
	virtual long GetPosition() const;
	virtual void SetPosition(long position);
	
protected:
	FW_CStorageUnitSink(const FW_CStorageUnitSink& sink);
	FW_CStorageUnitSink& operator=(const FW_CStorageUnitSink& sink);

private:
	// ----- Not supported -----
	virtual const void* ReadPeek(long& availableReadBytes);
	virtual void* WritePeek(long& availableWriteBytes);

private:
	XMPStorageUnit*		fStorageUnit;
};

#endif