//========================================================================================
//
//	File:				FWStrmRW.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSTRMRW_H
#include "FWStrmRW.h"
#endif

#ifndef FWEXCDEF_H
#include "FWExcDef.h"
#endif

#pragma segment FWStream

//========================================================================================
//	CLASS FW_CReadableStream
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CReadableStream::FW_CReadableStream
//----------------------------------------------------------------------------------------

FW_CReadableStream::FW_CReadableStream(FW_CSink* sink,
									   FW_CReadableStreamFormatter* formatter) :
	fSink(sink),
	fStreamCreatedFormatter(formatter ? FALSE : TRUE),
	fFormatter(formatter)
{
	if (fStreamCreatedFormatter)
		fFormatter = FW_NEW(FW_CReadableStreamFormatter, ());

	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
// FW_CReadableStream::~FW_CReadableStream
//----------------------------------------------------------------------------------------

FW_CReadableStream::~FW_CReadableStream()
{
	FW_START_DESTRUCTOR
	
	if (fStreamCreatedFormatter)
		delete fFormatter;
}


//========================================================================================
//	CLASS FW_CWritableStream
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CWritableStream::FW_CWritableStream
//----------------------------------------------------------------------------------------

FW_CWritableStream::FW_CWritableStream(FW_CSink* sink,
									   FW_CWritableStreamFormatter* formatter) :
	fSink(sink),
	fStreamCreatedFormatter(formatter ? FALSE : TRUE),
	fFormatter(formatter)
{
	if (fStreamCreatedFormatter)
		fFormatter = FW_NEW(FW_CWritableStreamFormatter, ());

	FW_END_CONSTRUCTOR
}

//----------------------------------------------------------------------------------------
// FW_CWritableStream::~FW_CWritableStream
//----------------------------------------------------------------------------------------

FW_CWritableStream::~FW_CWritableStream()
{
	FW_START_DESTRUCTOR
	
	if (fStreamCreatedFormatter)
		delete fFormatter;
}
