//========================================================================================
//
//	File:				FWDropTr.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWDROPTR_H
#define FWDROPTR_H

//========================================================================================
//	 Forward class declarations
//========================================================================================

class FW_CFacet;
struct FW_CRect;
struct FW_CPoint;

//========================================================================================
//	 class FW_CDropTracker
//========================================================================================

#define kFW_CDropTrackerID "appl:framework:cdroptracker$class,1.0.0"

class FW_CDropTracker
{
// ----- Initialization/destruction
public:
	FW_CDropTracker();
	virtual ~FW_CDropTracker();
	void InitDropTracker(FW_CFacet* facet);
	
// ----- Dispatch tracking
	void HandleBeginTracking(const FW_CPoint& where);
	void HandleContinueTracking(const FW_CPoint& where);
	void HandleEndTracking(const FW_CPoint& where);
	
// ----- Tracking
	virtual void BeginTracking(const FW_CPoint& where);
	virtual void ContinueTracking(const FW_CPoint& where) = 0;
	virtual void EndTracking(const FW_CPoint& where);

// ----- Fields
protected:
	FW_CFacet*	fFacet;
};

#endif

