//========================================================================================
//
//	File:				FWEventH.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWEVENTH_H
#define FWEVENTH_H

#ifndef FWSTDDEF_H
#include <FWStdDef.h>
#endif

// ----- OpenDoc Includes -----

#ifndef _XMPTYPES_
#include <XMPTypes.h>
#endif

//==============================================================================
//	 Constants
//==============================================================================

const XMPID kNoIdentifier = 0xFFFFFFFF;

//==============================================================================
//	 class FW_MEventHandler
//==============================================================================

class FW_MEventHandler
{
public:
	virtual ~ CDECL FW_MEventHandler();

	XMPID				GetIdentifier() const;
	virtual void		SetIdentifier(XMPID identifier);
	
	FW_MEventHandler*	GetNextEventHandler() const;
	void				SetNextEventHandler(FW_MEventHandler* nextEventHandler);
	
	virtual FW_Boolean	IsActive() const;
	virtual FW_Boolean	Activate();
	virtual void		Deactivate();
	
protected:
	FW_MEventHandler();

private:
	XMPID				fIdentifier;
	FW_MEventHandler	*fNextEventHandler;
	FW_Boolean			fActive;
};

//==============================================================================
//	 Inlines
//==============================================================================

//------------------------------------------------------------------------------
//	 FW_MEventHandler::GetIdentifier()
//------------------------------------------------------------------------------
inline XMPID FW_MEventHandler::GetIdentifier() const
{
	return fIdentifier;
}

//------------------------------------------------------------------------------
//	 FW_MEventHandler::GetNextEventHandler()
//------------------------------------------------------------------------------
inline FW_MEventHandler* FW_MEventHandler::GetNextEventHandler() const
{
	return fNextEventHandler;
}

//------------------------------------------------------------------------------
//	 FW_MEventHandler::SetNextEventHandler()
//------------------------------------------------------------------------------
inline void FW_MEventHandler::SetNextEventHandler(FW_MEventHandler* nextEventHandler)
{
	fNextEventHandler = nextEventHandler;
}

#endif
