//========================================================================================
//
//	File:				FWFrming.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWFRMING_H
#define FWFRMING_H

#ifndef FWFRAME_H
#include "FWFrame.h"
#endif

// ----- OPF Foundation Includes -----

#ifndef BCCOLLD_H
#include <BCCollD.h>
#endif

//==============================================================================
//	 Forward Declarations
//==============================================================================

class FW_CPart;
class FW_CProxyFrame;
class FW_CProxyRun;
class BC_CUnmanaged;

//==============================================================================
//	 class FW_CEmbeddingFrame
//==============================================================================

#define kFW_CEmbeddingFrameID "appl:framework:cembeddingframe$class,1.0.0"

class FW_CEmbeddingFrame : public FW_CFrame
{
//------------------------------------------------------------------------------
//	 Initialization/Destruction
//
public:
	FW_CEmbeddingFrame();
	void InitEmbeddingFrame(XMPFrame* xmpFrame, FW_CPart* part);
	virtual ~ CDECL FW_CEmbeddingFrame();
	
//------------------------------------------------------------------------------
//	 New API
//
public:
	enum
	{
		kChunkSize = 5				// Chunk size for proxy frames
	};

	// ----- Facets -----
	virtual void 			FacetAdded(FW_CFacet* facet);
	virtual void 			FacetRemoved(FW_CFacet* facet);

	// ----- Frame Negotiation -----
	virtual void			FrameShapeChanged();
	virtual void			UsedShapeChanged(FW_CProxyRun* proxyRun, XMPFrame* embeddedXMPFrame);

	// ----- Frame Hierarchy -----
	void					AttachSourceFrame(FW_CEmbeddingFrame* sourceFrame);
	void					RemoveEmbeddedFrame(FW_CProxyFrame* proxyFrame);	
	FW_CProxyFrame*			CreateEmbeddedFrame(XMPPart *embeddedXMPPart,
												FW_CProxyRun* proxyRun,
												XMPShape* frameShape,											
												XMPTypeToken viewType,
												XMPTypeToken presentation,
												XMPID frameGroupID,
												FW_Boolean isOverlaid);
	FW_CProxyFrame*			XMPtoProxyFrame(XMPFrame* xmpFrame) const;
	
	virtual void			AddedToDisplayList();
	virtual void			CloseDisplayFrame();
	virtual void			RemoveDisplayFrame();
	
	// ----- Menu Events -----
	virtual FW_Boolean		DoMenuEvent(XMPMenuBar *menuBar, XMPCommandID commandID);

	// ----- Part Info -----
	void					ShowPartInfo();

	// ----- Implementation methods
	void					ClipEmbeddedFrames();

	// ----- Embedded frames -----
	void					AddProxyFrame(FW_CProxyFrame* proxyFrame);
	void					RemoveProxyFrame(FW_CProxyFrame* proxyFrame);
	unsigned long				CountEmbeddedFrames() const;
	
	// ----- Getters -----
	BC_TDynamicCollection<FW_CProxyFrame*, BC_CUnmanaged>* GetProxyFrameList() const;
	
//------------------------------------------------------------------------------
//	 Data Members
//
private:
	BC_TDynamicCollection<FW_CProxyFrame*, BC_CUnmanaged>*	fProxyFrameList;
};

//==============================================================================
//	 Inlines
//==============================================================================

//------------------------------------------------------------------------------
//	 FW_CEmbeddingFrame::GetProxyFrameList
//------------------------------------------------------------------------------
inline BC_TDynamicCollection<FW_CProxyFrame*, BC_CUnmanaged>* FW_CEmbeddingFrame::GetProxyFrameList() const
{
	return fProxyFrameList;
}

#endif

