//========================================================================================
//
//	File:				FWSclBar.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWSCLBAR_H
#define FWSCLBAR_H

#ifndef FWVIEW_H
#include "FWView.h"
#endif

//========================================================================================
//	 Foward class declarations
//========================================================================================

class FW_CControlMgrHelper;


//========================================================================================
//	 CLASS FW_CScrollBar
//========================================================================================

#define kFW_CScrollBarID "appl:FW_CScrollBar$class,1.0.0"

class FW_CScrollBar : public FW_CView
{
// ----- Initialization/destruction
public:
						FW_CScrollBar();
	virtual				~FW_CScrollBar();
	
	void				InitScrollBar(CFacet* facet, FW_CView* enclosure,
									  XMPID identifier,
									  XMPTransform* transform, XMPShape* shape);
	void				InitScrollBar(FW_CView* enclosure,
									  XMPID identifier,
									  XMPTransform* transform, XMPShape* shape);

// ----- Update
public:
	virtual void 		Draw(XMPShape* area);

// ----- Mouse events
public:
	virtual FW_Boolean	MouseDown(const XMPPoint& where, XMPEventData event);
	
private:
	FW_CControlMgrHelper*		fControlMgrHelper;
};

//----------------------------------------------------------------------------------------
// FW_CView::InitView
//----------------------------------------------------------------------------------------

inline void FW_CScrollBar::InitScrollBar(FW_CView* enclosure, XMPID identifier,
										 XMPTransform* transform, XMPShape* shape)
{
	InitScrollBar(enclosure->GetFacet(), enclosure, identifier, transform, shape);
}

#endif
