//========================================================================================
//
//	File:				FWViewFa.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWVIEWFA_H
#define FWVIEWFA_H

// ----- Framework Includes

#ifndef FWFACET_H
#include "FWFacet.h"
#endif

//========================================================================================
// Forward class declarations
//========================================================================================

class FW_CView;
class XMPFacet;
class XMPShape;

//========================================================================================
// CLASS FW_CViewFacet
//========================================================================================

class FW_CViewFacet : public CFacet
{
// ----- Initialization/destruction
public:
							FW_CViewFacet();
	virtual					~FW_CViewFacet();
	
	void					InitViewFacet(XMPFacet* xmpFacet);
	
	virtual void			Draw(XMPShape* invalidShape);

	virtual FW_Boolean 		DoMouseDown(const XMPPoint& where,
										XMPEventData event);
	
	virtual FW_Boolean 		DoMouseUp(const XMPPoint& where,
									  XMPEventData event);

// ----- New API
public:
	FW_CView*				GetRootView() const;
	virtual void			SetRootView(FW_CView* view);
	
	virtual FW_CView*		CreateViewHierarchy() = 0;

// ----- Fields
private:
	FW_CView*				fRootView;
};

//----------------------------------------------------------------------------------------
// FW_CViewFacet::GetRootView
//----------------------------------------------------------------------------------------

FW_CView* FW_CViewFacet::GetRootView() const
{
	return fRootView;
}

#endif

