//========================================================================================
//
//	File:				FWDropTr.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWDROPTR_H
#include "FWDropTr.h"
#endif

#ifndef FWFACET_H
#include "FWFacet.h"
#endif

#ifndef FWUTIL_H
#include "FWUtil.h"
#endif

// ----- Graphic Includes -----

#ifndef FWRECT_H
#include "FWRect.h"
#endif

#ifndef FWPOINT_H
#include "FWPoint.h"
#endif

// ----- OpenDoc Includes -----

#ifndef _EXCEPT_
#include <Except.h>
#endif

#ifndef _TRNSFORM_
#include <TrnsForm.h>
#endif

#pragma segment framework

//========================================================================================
//	 class FW_CDropTracker
//========================================================================================

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::FW_CDropTracker
//----------------------------------------------------------------------------------------

FW_CDropTracker::FW_CDropTracker() :
	fFacet(NULL)
{
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::~FW_CDropTracker
//----------------------------------------------------------------------------------------

FW_CDropTracker::~FW_CDropTracker()
{
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::InitDropTracker
//----------------------------------------------------------------------------------------

void FW_CDropTracker::InitDropTracker(FW_CFacet* facet)
{
	ASSERT(facet != NULL, 0);
	fFacet = facet;
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::HandleBeginTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::HandleBeginTracking(const FW_CPoint& where)
{
	FW_CGraphicContext di(fFacet->GetXMPFacet());
	FW_CPoint windowWhere = fFacet->GetWindowContentTransform()->InvertPoint(where);
	this->BeginTracking(windowWhere);
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::HandleContinueTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::HandleContinueTracking(const FW_CPoint& where)
{
	FW_CGraphicContext di(fFacet->GetXMPFacet());
	FW_CPoint windowWhere = fFacet->GetWindowContentTransform()->InvertPoint(where);
	this->ContinueTracking(windowWhere);
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::HandleEndTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::HandleEndTracking(const FW_CPoint& where)
{
	FW_CGraphicContext di(fFacet->GetXMPFacet());
	FW_CPoint windowWhere = fFacet->GetWindowContentTransform()->InvertPoint(where);
	this->EndTracking(windowWhere);
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::BeginTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::BeginTracking(const FW_CPoint& where)
{
	this->ContinueTracking(where);
}

//----------------------------------------------------------------------------------------
//	 FW_CDropTracker::EndTracking
//----------------------------------------------------------------------------------------

void FW_CDropTracker::EndTracking(const FW_CPoint& where)
{
	this->ContinueTracking(where);
}

