//========================================================================================
//
//	File:				FWSclBar.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

// ----- Framework Includes

#ifndef FWSCLBAR_H
#include "FWSclBar.h"
#endif

#ifndef _FWCONTRH_
#include "FWContrH.h"
#endif

#ifndef FWFACET_H
#include "FWFacet.h"
#endif

// ----- OpenDoc Includes

#ifndef _POINT_
#include "FW_SPlatformPoint.h"
#endif

#ifndef _RECT_
#include "FW_SPlatformRect.h"
#endif

#ifndef _SHAPE_
#include "Shape.h"
#endif

#ifndef _EXCEPT_
#include "Except.h"
#endif

#ifndef _WINDOW_
#include "Window.h"
#endif

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(__CONTROLS__)
#include <Controls.h>
#endif


//========================================================================================
// CLASS FW_CScrollBar
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CScrollBar::FW_CScrollBar
//----------------------------------------------------------------------------------------

FW_CScrollBar::FW_CScrollBar() :
	fControlMgrHelper(NULL)
{
}

//----------------------------------------------------------------------------------------
// FW_CScrollBar::~FW_CScrollBar
//----------------------------------------------------------------------------------------

FW_CScrollBar::~FW_CScrollBar()
{
	delete fControlMgrHelper;
}

//----------------------------------------------------------------------------------------
// FW_CScrollBar::InitScrollBar
//----------------------------------------------------------------------------------------

void FW_CScrollBar::InitScrollBar(CFacet* facet, FW_CView* enclosure,
								  XMPID identifier,
								  XMPTransform* transform, XMPShape* shape)
{	
	this->InitView(facet, enclosure, identifier, transform, shape);
	
	ASSERT(shape->IsRectangular(), 0);
	
	XMPRect rect;
	shape->GetBoundingBox(&rect);
	
	FW_SPlatformRect qdRect;
	rect.AsPlatformRect(qdRect);
	
	fControlMgrHelper = new FW_CControlMgrHelper;
	fControlMgrHelper->InitControlMgrHelper(qdRect, "\p", 0, 0, 1, scrollBarProc);	
}

//----------------------------------------------------------------------------------------
// FW_CScrollBar::Draw
//----------------------------------------------------------------------------------------

void FW_CScrollBar::Draw(XMPShape* area)
{
FW_UNUSED(area);

	XMPPlatformWindow window = GetFacet()->GetXMPWindow()->GetPlatformWindow();
	fControlMgrHelper->Draw(window);
}

//----------------------------------------------------------------------------------------
// FW_CScrollBar::MouseDown
//----------------------------------------------------------------------------------------

FW_Boolean FW_CScrollBar::MouseDown(const XMPPoint& where, XMPEventData event)
{
FW_UNUSED(event);

	FW_CViewDrawInitiator di(this);

	XMPPlatformWindow window = GetFacet()->GetXMPWindow()->GetPlatformWindow();
	FW_SPlatformPoint qdPoint = where;
	
	fControlMgrHelper->MouseDown(window, qdPoint);
	
	return TRUE;
}
