//========================================================================================
//
//	File:				FWViewFa.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

// ----- Framework Includes

#ifndef _FWVIEWFA_
#include "FWViewFa.h"
#endif

#ifndef FWVIEW_H
#include "FWView.h"
#endif

#ifndef FWUTIL_H
#include "FWUtil.h"
#endif


//========================================================================================
// CLASS FW_CViewFacet
//========================================================================================

//----------------------------------------------------------------------------------------
// FW_CViewFacet::FW_CViewFacet
//----------------------------------------------------------------------------------------

FW_CViewFacet::FW_CViewFacet() :
	fRootView(NULL)
{
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::~FW_CViewFacet
//----------------------------------------------------------------------------------------

FW_CViewFacet::~FW_CViewFacet()
{
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::InitViewFacet
//----------------------------------------------------------------------------------------

void FW_CViewFacet::InitViewFacet(XMPFacet* xmpFacet)
{
	CFacet::InitFacet(xmpFacet);
	SetRootView(CreateViewHierarchy());
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::Draw
//----------------------------------------------------------------------------------------

void FW_CViewFacet::Draw(XMPShape* invalidShape)
{
	fRootView->HandleDraw(invalidShape);
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::DoMouseDown
//----------------------------------------------------------------------------------------

FW_Boolean FW_CViewFacet::DoMouseDown(const XMPPoint& where, XMPEventData event)
{
	CDrawInitiator di(this);
	return fRootView->HandleMouseDown(where, event);
}
	
//----------------------------------------------------------------------------------------
// FW_CViewFacet::DoMouseUp
//----------------------------------------------------------------------------------------

FW_Boolean FW_CViewFacet::DoMouseUp(const XMPPoint& where, XMPEventData event)
{
	CDrawInitiator di(this);
	return fRootView->HandleMouseUp(where, event);
}

//----------------------------------------------------------------------------------------
// FW_CViewFacet::SetRootView
//----------------------------------------------------------------------------------------

void FW_CViewFacet::SetRootView(FW_CView* view)
{
	fRootView = view;
}
