//========================================================================================
//
//	File:				FWDfault.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWDFAULT_H
#define FWDFAULT_H

#ifndef FWGCONST_H
#include "FWGConst.h"
#endif

#ifndef FWINK_H
#include "FWInk.h"
#endif

#ifndef FWSTYLE_H
#include "FWStyle.h"
#endif

#ifndef FWRECT_H
#include "FWRect.h"
#endif

//========================================================================================
//	 struct FW_SDefaultProperties
//========================================================================================

struct FW_SDefaultProperties
{
	FW_SDefaultProperties();
	FW_SDefaultProperties(FW_CInk ink, FW_CStyle style, FW_ShapeFills fill);
	
	FW_CInk			fInk;
	FW_CStyle		fStyle;
	FW_ShapeFills	fFill;
};

//========================================================================================
//	 FW_SGraphicGlobales
//========================================================================================

struct FW_SGraphicGlobales
{
	FW_SGraphicGlobales();
	
	unsigned long			gSeed;
	
	FW_SDefaultProperties	gRect;
	FW_SDefaultProperties	gOval;
	FW_SDefaultProperties	gArc;
	FW_SDefaultProperties	gLine;
	FW_SDefaultProperties	gRoundRect;
	FW_SDefaultProperties	gText;
	FW_SDefaultProperties	gRegion;
	FW_SDefaultProperties	gBitmap;
	FW_SDefaultProperties	gPicture;
	
	FW_CGraphicContext* 	gLastGC;

#ifdef FW_BUILD_MAC
	WindowPtr 				gScratchWindow;
#endif
};

//========================================================================================
//	 Globales
//========================================================================================

const FW_CPoint 	FW_kZeroPoint(0,0);
const FW_CRect 		FW_kZeroRect(0,0,0,0);

FW_SGraphicGlobales gGraphicGlobales;

#endif