//========================================================================================
//
//	File:				FWWinGDI.h
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#if defined(FW_BUILD_WIN) && !defined(FWWINGDI_H)
#define FWWINGDI_H

#ifndef FWGROBJ_H
#include "FWGrObj.h"
#endif

// ----- Windows Includes -----
#ifndef _INC_WINDOWS
#include <Windows.h>
#endif

//==============================================================================
//	 CLASS FW_CWinGDIObjectList
//==============================================================================

class FW_CWinGDIObjectList
{
public:
	FW_CWinGDIObjectList();
	virtual ~FW_CWinGDIObjectList();

	void AddGDIObject(FW_CWinGDIObjectRep objectRep);
	void RemoveGDIObject(FW_CWinGDIObjectRep objectRep);
};

//==============================================================================
//	 CLASS FW_CWinGDIObject
//==============================================================================

class FW_CWinGDIObject : public FW_CGraphicObjectPtr
{
//------------------------------------------------------------------------------
//	 Constructors/Destructors
//
public:
	FW_CWinGDIObject();
	FW_CWinGDIObject(const FW_CWinGDIObject& other);

protected:	
	FW_CWinGDIObject(FW_CWinGDIObjectRep* rep);
	
//------------------------------------------------------------------------------
//	 New API
//
public:
	static FW_CWinGDIObject FromHandle(HGDIOBJECT);

//------------------------------------------------------------------------------
//	 Data Members
//
private:
	static FW_CWinGDIObjectList	fGDIObjectsList;
};

//==============================================================================
//	 CLASS FW_CWinGDIObjectRep
//==============================================================================

class FW_CWinGDIObjectRep : public FW_CGraphicObjectRep
{

//------------------------------------------------------------------------------
//	 Constructors/Destructors
//
protected:
	FW_CWinGDIObjectRep();
	FW_CWinGDIObjectRep(HGDIOBJECT hGDIObject, FW_Boolean stockObject = FALSE);
	virtual ~FW_CWinGDIObjectRep();

//------------------------------------------------------------------------------
//	 New API
//
public:
	FW_Boolean 		IsSelected() const
						{return fSelected;}

	void			SelectObject(FW_CGraphicContext* gc);
	
	HGDIOBJECT		GetGDIObject() const
						{return fGDIObject;}
	
//------------------------------------------------------------------------------
//	 Data Members
//
private:
	FW_Boolean				fSelected;
	FW_Boolean				fIsTemporary;
	HGDIOBJECT				fGDIObject;
	FW_CWinGDIObject		fPreviousObject;
};

#endif
