//========================================================================================
//
//	File:				FWDfault.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifndef FWDFAULT_H
#include "FWDfault.h"
#endif

#ifndef FWCOLOR_H
#include "FWColor.h"
#endif

// ----- Macintosh Includes -----

#if defined(FW_BUILD_MAC) && !defined(mathRoutinesIncludes)
#include <math routines.h>
#endif

//==============================================================================
//	 RunTime Info
//==============================================================================

#ifdef FW_BUILD_MAC
#pragma segment fwgraphx
#endif

//==============================================================================
//	 struct FW_SDefaultProperties
//==============================================================================

//------------------------------------------------------------------------------
//	FW_SDefaultProperties::FW_SDefaultProperties
//------------------------------------------------------------------------------

FW_SDefaultProperties::FW_SDefaultProperties(FW_CInk ink, FW_CStyle style, FW_ShapeFills fill) :
	fInk(ink),
	fStyle(style),
	fFill(fill)
{	
}

//------------------------------------------------------------------------------
//	FW_SDefaultProperties::FW_SDefaultProperties
//------------------------------------------------------------------------------

FW_SDefaultProperties::FW_SDefaultProperties() :
	fInk(FW_kRGBBlack, FW_kRGBWhite, FW_kCopy),
	fStyle(ff(1)),
	fFill(FW_kFilled)
{	
}

//==============================================================================
//	 struct FW_SGraphicGlobales
//==============================================================================

//------------------------------------------------------------------------------
//	FW_SGraphicGlobales::FW_SGraphicGlobales
//------------------------------------------------------------------------------

FW_SGraphicGlobales::FW_SGraphicGlobales() :
	gSeed(0),
	gRect(),
	gOval(),
	gArc(),
	gLine(),
	gRoundRect(),
	gText(FW_CInk(FW_kRGBBlack, FW_kRGBWhite, FW_kOr), FW_CStyle("", FW_kPlain, ff(12)), FW_kFilled),
	gRegion(),
	gBitmap(),
	gPicture(),
	gLastGC(NULL)
#ifdef FW_BUILD_MAC
	,gScratchWindow(NULL)
#endif
{	
}
