//========================================================================================
//
//	File:				FWWinGDI.cpp
//	Release Version:	$ 1.0d1 $
//
//	Creation Date:		3/28/94
//
//	Copyright:	 1993, 1994 by Apple Computer, Inc., all rights reserved.
//
//========================================================================================

#ifdef FW_BUILD_WIN

#ifndef FWWINGDI_H
#include "FWWinGDI.h"
#endif

FW_CWinGDIObjectList FW_CWinGDIObject::fGDIObjectsList;

//==============================================================================
//	 CLASS FW_CWinGDIObject
//==============================================================================

//------------------------------------------------------------------------------
//	FW_CWinGDIObject::FW_CWinGDIObject
//------------------------------------------------------------------------------

FW_CWinGDIObject::FW_CWinGDIObject() :
	FW_CGraphicObjectPtr()
{
}

//------------------------------------------------------------------------------
//	FW_CWinGDIObject::FW_CWinGDIObject
//------------------------------------------------------------------------------

FW_CWinGDIObject::FW_CWinGDIObject(const FW_CWinGDIObject& other) :
	FW_CGraphicObjectPtr(other)
{
}

//------------------------------------------------------------------------------
//	FW_CWinGDIObject::FW_CWinGDIObject
//------------------------------------------------------------------------------

FW_CWinGDIObject::FW_CWinGDIObject(FW_CWinGDIObjectRep* rep) :
	FW_CGraphicObjectPtr(rep)
{
}

//==============================================================================
//	 CLASS FW_CWinGDIObjectRep
//==============================================================================

//------------------------------------------------------------------------------
//	FW_CWinGDIObjectRep::FW_CWinGDIObjectRep
//------------------------------------------------------------------------------

FW_CWinGDIObjectRep::FW_CWinGDIObjectRep() :
	fSelectCount(FALSE),
	fIsTemporary(FALSE),
	fGDIObject(NULL)
{
}

//------------------------------------------------------------------------------
//	FW_CWinGDIObjectRep::FW_CWinGDIObjectRep
//------------------------------------------------------------------------------

FW_CWinGDIObjectRep::FW_CWinGDIObjectRep(HGDIOBJECT hGDIObject, FW_Boolean stockObject) :
	fSelectCount(FALSE),
	fIsTemporary(stockObject)
	fGDIObject(hGDIObject)
{
}

//------------------------------------------------------------------------------
//	FW_CWinGDIObjectRep::FW_CWinGDIObjectRep
//------------------------------------------------------------------------------

FW_CWinGDIObjectRep::~FW_CWinGDIObjectRep()
{
	if (fGDIObject && !fIsTemporary)
	{
		
		::DeleteObject(fGDIObject);
		fGDIObject = NULL;
	}
}

//------------------------------------------------------------------------------
//	FW_CWinGDIObjectRep::Select
//------------------------------------------------------------------------------

void FW_CWinGDIObjectRep::SelectObject(FW_CGraphicContext* gc)
{
	fPreviousObject = gc->SelectObject(this);
	fSelected = TRUE;
}

#endif